unit AkelEdit_h;

(*************************************************************************

 Converted with C to Pascal Converter 2.0
 Release: 2.12.7.2009
 Email: al_gun@ncable.net.au
 Updates: http://cc.codegear.com/Author/302259
 Copyright (c) 2005-2009, Ural Gunaydin

**************************************************************************)

interface

uses
 Windows, Messages, ShellAPI, SysUtils, Classes, RichEdit;

// Defines
const
  AES_AKELEDITCLASSA  = 'AkelEditA';
  {$EXTERNALSYM AES_AKELEDITCLASSA}
  AES_AKELEDITCLASSW  = 'AkelEditW';
  {$EXTERNALSYM AES_AKELEDITCLASSW}
  AES_RICHEDITCLASSA  = 'RichEdit20A';
  {$EXTERNALSYM AES_RICHEDITCLASSA}
  AES_RICHEDITCLASSW  = 'RichEdit20W';
  {$EXTERNALSYM AES_RICHEDITCLASSW}

  //AEM_CONTROLCLASS
  AECLASS_AKELEDIT    = 1;
  {$EXTERNALSYM AECLASS_AKELEDIT}
  AECLASS_RICHEDIT    = 2;
  {$EXTERNALSYM AECLASS_RICHEDIT}

  AES_WORDDELIMITERSW = ' \|[](){}<>,.;:+-=~!@#$%^&*/?`"'#9#10#39;
  {$EXTERNALSYM AES_WORDDELIMITERSW}
  AES_WRAPDELIMITERSW = ' '#9;
  {$EXTERNALSYM AES_WRAPDELIMITERSW}
  AES_URLDELIMITERSW  = ' ()<>`"'#9#10#39;
  {$EXTERNALSYM AES_URLDELIMITERSW}
  AES_URLPREFIXESW    = 'http:'#0'https:'#0'www.'#0'ftp:'#0'file:'#0'mailto:'#0#0;
  {$EXTERNALSYM AES_URLPREFIXESW}

  //AEM_SETEVENTMASK flags
  AENM_SELCHANGE  = $00000001; // Sends AEN_SELCHANGING and AEN_SELCHANGED notifications.
  {$EXTERNALSYM AENM_SELCHANGE}
  AENM_TEXTCHANGE = $00000002; // Sends AEN_TEXTCHANGING and AEN_TEXTCHANGED notifications.
  {$EXTERNALSYM AENM_TEXTCHANGE}
  AENM_MODIFY     = $00000004; // Sends AEN_MODIFY notifications.
  {$EXTERNALSYM AENM_MODIFY}
  AENM_SCROLL     = $00000008; // Sends AEN_HSCROLL and AEN_VSCROLL notifications.
  {$EXTERNALSYM AENM_SCROLL}
  AENM_DROPFILES  = $00000010; // Sends AEN_DROPFILES notifications.
  {$EXTERNALSYM AENM_DROPFILES}
  AENM_DRAGDROP   = $00000020; // Sends AEN_DROPSOURCE and AEN_DROPTARGET notifications.
  {$EXTERNALSYM AENM_DRAGDROP}
  AENM_LINK       = $00000040; // Sends AEN_LINK notifications.
  {$EXTERNALSYM AENM_LINK}
  AENM_PROGRESS   = $00000080; // Sends AEN_PROGRESS notifications.
  {$EXTERNALSYM AENM_PROGRESS}

  //AEN_TEXTCHANGING and AEN_TEXTCHANGED flags
  AETCT_REPLACESEL    = $00000001; // Replace selection.
  {$EXTERNALSYM AETCT_REPLACESEL}
  AETCT_APPENDTEXT    = $00000002; // Append text.
  {$EXTERNALSYM AETCT_APPENDTEXT}
  AETCT_SETTEXT       = $00000004; // Set text.
  {$EXTERNALSYM AETCT_SETTEXT}
  AETCT_STREAMIN      = $00000008; // Stream in.
  {$EXTERNALSYM AETCT_STREAMIN}
  AETCT_STREAMOUT     = $00000010; // Stream out.
  {$EXTERNALSYM AETCT_STREAMOUT}
  AETCT_UNDO          = $00000020; // Undo.
  {$EXTERNALSYM AETCT_UNDO}
  AETCT_REDO          = $00000040; // Redo.
  {$EXTERNALSYM AETCT_REDO}
  AETCT_CUT           = $00000080; // Cut.
  {$EXTERNALSYM AETCT_CUT}
  AETCT_CHAR          = $00000100; // Insert char.
  {$EXTERNALSYM AETCT_CHAR}
  AETCT_KEYRETURN     = $00000200; // Pressed VK_RETURN.
  {$EXTERNALSYM AETCT_KEYRETURN}
  AETCT_KEYBACKSPACE  = $00000400; // Pressed VK_BACK.
  {$EXTERNALSYM AETCT_KEYBACKSPACE}
  AETCT_KEYDELETE     = $00000800; // Pressed VK_DELETE.
  {$EXTERNALSYM AETCT_KEYDELETE}
  AETCT_DRAGDELETE    = $00001000; // Dragging text delete.
  {$EXTERNALSYM AETCT_DRAGDELETE}
  AETCT_DROPINSERT    = $00002000; // Dropping text insert.
  {$EXTERNALSYM AETCT_DROPINSERT}

  //AEN_TEXTCHANGED flags
  AETCT_NONE      = $00100000; // No text is changed.
  {$EXTERNALSYM AETCT_NONE}
  AETCT_DELETEALL = $00200000; // Indicate that due to AETCT_* action all text has been modified.
  {$EXTERNALSYM AETCT_DELETEALL}

  //AEN_DROPTARGET actions
  AEDT_TARGETENTER    = 1;        // Enter into the target window.
  {$EXTERNALSYM AEDT_TARGETENTER}
  AEDT_TARGETOVER     = 2;        // Moving over the target window.
  {$EXTERNALSYM AEDT_TARGETOVER}
  AEDT_TARGETLEAVE    = 3;        // Leaving the target window.
  {$EXTERNALSYM AEDT_TARGETLEAVE}
  AEDT_TARGETDROP     = 4;        // Drops the data into the target window.
  {$EXTERNALSYM AEDT_TARGETDROP}

  //AEN_DROPSOURCE actions
  AEDS_SOURCEBEGIN    = 1;        // cBegin selection dragging.
  {$EXTERNALSYM AEDS_SOURCEBEGIN}
  AEDS_SOURCEEND      = 2;        // End selection dragging.
  {$EXTERNALSYM AEDS_SOURCEEND}

  //AEN_PROGRESS type
  AEPGS_SETTEXT       = $00000001; // Setting text.
  {$EXTERNALSYM AEPGS_SETTEXT}
  AEPGS_WRAPTEXT      = $00000002; // Wrapping text.
  {$EXTERNALSYM AEPGS_WRAPTEXT}
  AEPGS_STREAMIN      = $00000004; // Receiving stream text.
  {$EXTERNALSYM AEPGS_STREAMIN}

  //AEM_SETOPTIONS flags
  AECO_READONLY          = $00000001; // Set read-only mode. You can use ES_READONLY window style.
  {$EXTERNALSYM AECO_READONLY}
  AECO_DISABLENOSCROLL   = $00000002; // Disables scroll bars instead of hiding
                                      // them when they are not needed. You can
                                      // use ES_DISABLENOSCROLL window style.

  {$EXTERNALSYM AECO_DISABLENOSCROLL}
  AECO_NOHIDESEL         = $00000004; // If you do not specify this style, then
                                      // hides the selection when the control
                                      // loses the input focus and inverts the
                                      // selection when the control receives the
                                      // input focus. You can use ES_NOHIDESEL
                                      // window style.
  {$EXTERNALSYM AECO_NOHIDESEL}
  AECO_WANTRETURN        = $00000008; // If you do not specify this style, pressing
                                      // the ENTER key has the same effect as
                                      // pressing the dialog box's default push
                                      // button. You can use ES_WANTRETURN window style.
  {$EXTERNALSYM AECO_WANTRETURN}
  AECO_DETAILEDUNDO      = $00000010; // The control stores any typing action,
                                      // into a new action in the undo queue.
  {$EXTERNALSYM AECO_DETAILEDUNDO}
  AECO_DISABLEBEEP       = $00000020; // Disables sound beep, when unallowable
                                      // ction occur.
  {$EXTERNALSYM AECO_DISABLEBEEP}
  AECO_PASTESELECTCOLUMN = $00000040; // Selects pasted text in column mode.
  {$EXTERNALSYM AECO_PASTESELECTCOLUMN}
  AECO_DISABLEDRAG       = $00000080; // Disables OLE text dragging.
  {$EXTERNALSYM AECO_DISABLEDRAG}
  AECO_DISABLEDROP       = $00000100; // Disables OLE text dropping.
  {$EXTERNALSYM AECO_DISABLEDROP}
  AECO_CARETOUTEDGE      = $00000200; // Allow caret moving out of the line edge.
  {$EXTERNALSYM AECO_CARETOUTEDGE}
  AECO_ACTIVECOLUMN      = $00000400; // Draw caret vertical line.
  {$EXTERNALSYM AECO_ACTIVECOLUMN}
  AECO_PAINTGROUP        = $00000800; // Paint text by group of characters (default
                                      // is character by character). With this
                                      // style combined unicode symbols can be
                                      // drawn correctly but editing of whose
                                      // characters isn't comfortable.
  {$EXTERNALSYM AECO_PAINTGROUP}

  AECO_ALTDECINPUT       = $00001000; // Do Alt+NumPad decimal input with NumLock
                                      // on (default is decimal input after
                                      // two "Num 0").
  {$EXTERNALSYM AECO_ALTDECINPUT}

  AECOOP_SET = 1; // Sets the options to those specified by lParam.
  {$EXTERNALSYM AECOOP_SET}
  AECOOP_OR  = 2; // Combines the specified options with the current options.
  {$EXTERNALSYM AECOOP_OR}
  AECOOP_AND = 3; // Retains only those current options that are also specified by lParam.
  {$EXTERNALSYM AECOOP_AND}
  AECOOP_XOR = 4; // Logically exclusive OR the current options with those specified by lParam.
  {$EXTERNALSYM AECOOP_XOR}

  //Modifier flags
  AEMOD_ALT     = $01; // ALT key
  {$EXTERNALSYM AEMOD_ALT}
  AEMOD_SHIFT   = $02; //  key
  {$EXTERNALSYM AEMOD_SHIFT}
  AEMOD_CONTROL = $04; // CTRL key
  {$EXTERNALSYM AEMOD_CONTROL}

  //AEM_GETLINENUMBER flags
  AEGL_LINECOUNT            = 0; // Total number of text lines. If the control
                                 // has no text, the return value is 1.
  {$EXTERNALSYM AEGL_LINECOUNT}
  AEGL_FIRSTSELLINE         = 1; // First line of the selection.
  {$EXTERNALSYM AEGL_FIRSTSELLINE}
  AEGL_LASTSELLINE          = 2; // Last line of the selection.
  {$EXTERNALSYM AEGL_LASTSELLINE}
  AEGL_CARETLINE            = 3; // Caret line.
  {$EXTERNALSYM AEGL_CARETLINE}
  AEGL_FIRSTVISIBLELINE     = 4; // First visible line.
  {$EXTERNALSYM AEGL_FIRSTVISIBLELINE}
  AEGL_LASTVISIBLELINE      = 5; // Last visible line.
  {$EXTERNALSYM AEGL_LASTVISIBLELINE}
  AEGL_FIRSTFULLVISIBLELINE = 6; // First fully visible line.
  {$EXTERNALSYM AEGL_FIRSTFULLVISIBLELINE}
  AEGL_LASTFULLVISIBLELINE  = 7; // Last fully visible line.
  {$EXTERNALSYM AEGL_LASTFULLVISIBLELINE}

  //AEM_GETINDEX flags
  AEGI_FIRSTCHAR            = 1;  // First character.
  {$EXTERNALSYM AEGI_FIRSTCHAR}
  AEGI_LASTCHAR             = 2;  // Last character.
  {$EXTERNALSYM AEGI_LASTCHAR}
  AEGI_FIRSTSELCHAR         = 3;  // First character of the selection.
  {$EXTERNALSYM AEGI_FIRSTSELCHAR}
  AEGI_LASTSELCHAR          = 4;  // Last character of the selection.
  {$EXTERNALSYM AEGI_LASTSELCHAR}
  AEGI_CARETCHAR            = 5;  // Caret character.
  {$EXTERNALSYM AEGI_CARETCHAR}
  AEGI_FIRSTVISIBLELINE     = 6;  // First character of the first visible line.
  {$EXTERNALSYM AEGI_FIRSTVISIBLELINE}
  AEGI_LASTVISIBLELINE      = 7;  // Last character of the last visible line.
  {$EXTERNALSYM AEGI_LASTVISIBLELINE}
  AEGI_NEXTLINE             = 8;  // First character of the next line. lParam
                                  // must point to an input index.
  {$EXTERNALSYM AEGI_NEXTLINE}
  AEGI_PREVLINE             = 9;  // First character of the previous line.
                                  // lParam must point to an input index.
  {$EXTERNALSYM AEGI_PREVLINE}
  AEGI_NEXTCHAR             = 10;  // Next wide character. lParam must point to
                                   // an input index.
  {$EXTERNALSYM AEGI_NEXTCHAR}
  AEGI_PREVCHAR             = 11;  // Previous wide character. lParam must point
                                   // to an input index.
  {$EXTERNALSYM AEGI_PREVCHAR}
  AEGI_NEXTBREAK            = 12;  // Next break index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_NEXTBREAK}
  AEGI_PREVBREAK            = 13;  // Previous break index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_PREVBREAK}
  AEGI_NEXTWORDSTART        = 14;  // Next word start index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_NEXTWORDSTART}
  AEGI_NEXTWORDEND          = 15;  // Next word end index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_NEXTWORDEND}
  AEGI_PREVWORDSTART        = 16;  // Previous word start index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_PREVWORDSTART}
  AEGI_PREVWORDEND          = 17;  // Previous word end index, see AEM_SETWORDDELIMITERS.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_PREVWORDEND}
  AEGI_WRAPLINEBEGIN        = 18;  // First character of the unwrapped line.
                                   // Returns number of characters as AEM_GETINDEX
                                   // result. lParam must point to an input index.
  {$EXTERNALSYM AEGI_WRAPLINEBEGIN}
  AEGI_WRAPLINEEND          = 19;  // Last character of the unwrapped line. Returns
                                   // number of characters as AEM_GETINDEX result.
                                   // lParam must point to an input index.
  {$EXTERNALSYM AEGI_WRAPLINEEND}
  AEGI_NEXTCHARINLINE       = 20;  // Next character in line. lParam must point
                                   // to an input index.
  {$EXTERNALSYM AEGI_NEXTCHARINLINE}
  AEGI_PREVCHARINLINE       = 21;  // Previous character in line. lParam must
                                   // point to an input index.
  {$EXTERNALSYM AEGI_PREVCHARINLINE}
  AEGI_FIRSTFULLVISIBLELINE = 22; // First character of the first fully visible line.
  AEGI_LASTFULLVISIBLELINE  = 23; // Last character of the last fully visible line.

  //AEM_ISDELIMITER parameter
  AEDLM_WORD =     0; // Word delimiter.
  {$EXTERNALSYM AEDLM_WORD}
  AEDLM_WRAP =     1; // Wrap delimiter.
  {$EXTERNALSYM AEDLM_WRAP}
  AEDLM_URL =      2; // URL delimiter.
  {$EXTERNALSYM AEDLM_URL}


  //AEM_SETSEL and AEM_UPDATESEL flags
  AESELT_COLUMNON            = $00000001; // Make column selection ON.
  {$EXTERNALSYM AESELT_COLUMNON}
  AESELT_COLUMNASIS          = $00000020; // Leave column selection as is.
  {$EXTERNALSYM AESELT_COLUMNASIS}

  AESELT_LOCKNOTIFY          = $00000004; // Disable AEN_SELCHANGING and
                                          // AEN_SELCHANGED notifications.
  {$EXTERNALSYM AESELT_LOCKNOTIFY}
  AESELT_LOCKSCROLL          = $00000008; // Lock edit window scroll.
  {$EXTERNALSYM AESELT_LOCKSCROLL}
  AESELT_LOCKUPDATE          = $00000010; // Lock edit window update.
  {$EXTERNALSYM AESELT_LOCKUPDATE}
  AESELT_LOCKCARET           = $00000020; // Lock caret reposition.
  {$EXTERNALSYM AESELT_LOCKCARET}
  AESELT_LOCKUNDOGROUPING    = $00000040; // Don't use it. For internal code only.
  {$EXTERNALSYM AESELT_LOCKUNDOGROUPING}
  AESELT_NOCARETHORZINDENT   = $00000080; // Caret horizontal indent isn't changed.
  {$EXTERNALSYM AESELT_NOCARETHORZINDENT}
  AESELT_NOVERTSCROLLCORRECT = $00000100; // On some conditions scroll can be
                                          // increased to a height of one line.
  {$EXTERNALSYM AESELT_NOVERTSCROLLCORRECT}
  AESELT_MOUSE              =  $00000200; // Don't use it. For internal code only.
  {$EXTERNALSYM AESELT_MOUSE}

  //AEM_CHARFROMPOS return value
  AEPC_ERROR =     0; // Error.
  {$EXTERNALSYM AEPC_ERROR}
  AEPC_EQUAL =     1; // Char exactly in specified position.
  {$EXTERNALSYM AEPC_EQUAL}
  AEPC_BEFORE =    2; // Char before the specified position.
  {$EXTERNALSYM AEPC_BEFORE}
  AEPC_AFTER =     3; // Char after the specified position.
  {$EXTERNALSYM AEPC_AFTER}

  //New line value
  AELB_ASIS =     1; // Use new line of the source.
  {$EXTERNALSYM AELB_ASIS}
  AELB_ASINPUT =  2; // Use input new line, see AEM_SETNEWLINE with AENL_INPUT.
  {$EXTERNALSYM AELB_ASINPUT}
  AELB_ASOUTPUT = 3; // Use output new line, see AEM_SETNEWLINE with AENL_OUTPUT.
  {$EXTERNALSYM AELB_ASOUTPUT}
  AELB_EOF =      4; // nd-of-file new line.
  {$EXTERNALSYM AELB_EOF}
  AELB_R =        5; // #13 new line.
  {$EXTERNALSYM AELB_R}
  AELB_N =        6; // #10 new line.
  {$EXTERNALSYM AELB_N}
  AELB_RN =       7; // #13#10 new line.
  {$EXTERNALSYM AELB_RN}
  AELB_RRN =      8; // #13#13#10 new line.
  {$EXTERNALSYM AELB_RRN}
  AELB_WRAP =     9; // No new line, this line is wrapped.
  {$EXTERNALSYM AELB_WRAP}

  //AEM_SETNEWLINE flags
  AENL_INPUT           = $00000001; // Sets default new line for the input
                                    // operations, for example AEM_PASTE.
  {$EXTERNALSYM AENL_INPUT}
  AENL_OUTPUT          = $00000002; // Sets default new line for the output
                                    // operations, for example AEM_COPY.
  {$EXTERNALSYM AENL_OUTPUT}

  //AEM_SETCOLORS flags
  AECLR_DEFAULT        = $00000001; // Use default system colors for the specified
                                    // flags, all members of the AECOLORS
                                    // structure are ignored.
  {$EXTERNALSYM AECLR_DEFAULT}
  AECLR_CARET          = $00000002; // Sets caret color. crCaret member is valid.
  {$EXTERNALSYM AECLR_CARET}
  AECLR_BASICTEXT      = $00000004; // Sets basic text color. crBasicText member is valid.
  {$EXTERNALSYM AECLR_BASICTEXT}
  AECLR_BASICBK        = $00000008; // Sets basic background color. crBasicBk member is valid.
  {$EXTERNALSYM AECLR_BASICBK}
  AECLR_SELTEXT        = $00000010; // Sets text in selection color. crSelText member is valid.
  {$EXTERNALSYM AECLR_SELTEXT}
  AECLR_SELBK          = $00000020; // Sets background in selection color. crSelBk member is valid.
  {$EXTERNALSYM AECLR_SELBK}
  AECLR_ACTIVELINETEXT = $00000040; // Sets active line text color. crActiveLineText member is valid.
  {$EXTERNALSYM AECLR_ACTIVELINETEXT}
  AECLR_ACTIVELINEBK   = $00000080; // Sets active line background color. crActiveLineBk member is valid.
  {$EXTERNALSYM AECLR_ACTIVELINEBK}
  AECLR_URLTEXT        = $00000100; // Sets hiperlink text color. crUrlText member is valid.
  {$EXTERNALSYM AECLR_URLTEXT}
  AECLR_ACTIVECOLUMN   = $00000200; // Sets active column color. crActiveColumn member is valid.
  {$EXTERNALSYM AECLR_ACTIVECOLUMN}
  AECLR_COLUMNMARKER   = $00000400; //Sets column marker color. crColumnMarker member is valid.
  {$EXTERNALSYM AECLR_COLUMNMARKER}

  AECLR_ALL = (AECLR_CARET or AECLR_BASICTEXT or AECLR_BASICBK or AECLR_SELTEXT or
    AECLR_SELBK or AECLR_ACTIVELINETEXT or AECLR_ACTIVELINEBK or AECLR_URLTEXT or
    AECLR_ACTIVECOLUMN or AECLR_COLUMNMARKER);
  {$EXTERNALSYM AECLR_ALL}

  //Print
  AEPRN_TEST =                      $01; // Calculate data without painting.
  {$EXTERNALSYM AEPRN_TEST}
  AEPRN_INHUNDREDTHSOFMILLIMETERS = $02; // Indicates that hundredths of millimeters
                                         // are the unit of measurement for margins.
  {$EXTERNALSYM AEPRN_INHUNDREDTHSOFMILLIMETERS}
  AEPRN_INTHOUSANDTHSOFINCHES =     $04; // Indicates that thousandths of inches
                                         // are the unit of measurement for margins.
  {$EXTERNALSYM AEPRN_INTHOUSANDTHSOFINCHES}
  AEPRN_WRAPNONE =                  $08; // Print without wrapping.
  {$EXTERNALSYM AEPRN_WRAPNONE}
  AEPRN_WRAPWORD =                  $10; // Print with word wrapping (default).
  {$EXTERNALSYM AEPRN_WRAPWORD}
  AEPRN_WRAPSYMBOL =                $20; // Print with symbols wrapping.
  {$EXTERNALSYM AEPRN_WRAPSYMBOL}
  AEPRN_IGNOREFORMFEED =            $40; // Ignore form-feed character '\f'.
  {$EXTERNALSYM AEPRN_IGNOREFORMFEED}
  AEPRN_ANSI =                      $80; // Ansi text output. Can solve draw problems on Win95/98/Me.
  {$EXTERNALSYM AEPRN_ANSI}

  //Highlight flags
  AEHLF_MATCHCASE              = $0001; // If set, the highlight operation is
                                        // case-sensitive. If not set, the highlight
                                        // operation is case-insensitive.
  {$EXTERNALSYM AEHLF_MATCHCASE}
  AEHLF_WORDCOMPOSITION        = $0002; // Word is a composition of characters.
                                        // For example, AEWORDITEM.pWord equal
                                        // to "1234567890" with this flag, means
                                        // highlight words that contain only digits.
  {$EXTERNALSYM AEHLF_WORDCOMPOSITION}
  AEHLF_QUOTEEND_REQUIRED      = $0004; // If quote end isn't found, text after
                                        // quote start will not be highlighted.
  {$EXTERNALSYM AEHLF_QUOTEEND_REQUIRED}
  AEHLF_QUOTESTART_ISDELIMITER = $0008; // Last meet delimiter used as quote start
                                        // (AEQUOTEITEM.pQuoteStart member is ignored).
  {$EXTERNALSYM AEHLF_QUOTESTART_ISDELIMITER}
  AEHLF_QUOTEEND_ISDELIMITER   = $0010; // First meet delimiter used as quote end
                                        // (AEQUOTEITEM.pQuoteEnd member is ignored).
  {$EXTERNALSYM AEHLF_QUOTEEND_ISDELIMITER}
  AEHLF_QUOTESTART_NOHIGHLIGHT = $0020; // Don't highlight quote start string.
  {$EXTERNALSYM AEHLF_QUOTESTART_NOHIGHLIGHT}
  AEHLF_QUOTEEND_NOHIGHLIGHT   = $0040; // Don't highlight quote end string.
  {$EXTERNALSYM AEHLF_QUOTEEND_NOHIGHLIGHT}
  AEHLF_QUOTESTART_NOMATCH     = $0080; // Don't match and don't highlight quote start string.
  {$EXTERNALSYM AEHLF_QUOTESTART_NOMATCH}
  AEHLF_QUOTEEND_NOMATCH       = $0100; // Don't match and don't highlight quote end string.
  {$EXTERNALSYM AEHLF_QUOTEEND_NOMATCH}
  AEHLF_QUOTESTART_ATLINESTART = $0200; // Quote start located at line start.
  {$EXTERNALSYM AEHLF_QUOTESTART_ATLINESTART}
  AEHLF_QUOTEEND_ATLINEEND     = $0400; // Quote end located at line end.
  {$EXTERNALSYM AEHLF_QUOTEEND_ATLINEEND}
  AEHLF_QUOTESTART_ISWORD      = $0800; // Quote start is surrounded with delimiters.
  {$EXTERNALSYM AEHLF_QUOTESTART_ISWORD}
  AEHLF_QUOTEEND_ISWORD        = $1000; // Quote end is surrounded with delimiters.
  {$EXTERNALSYM AEHLF_QUOTEEND_ISWORD}
  AEHLF_QUOTEWITHOUTDELIMITERS = $2000; // Quote doesn't contain delimiters.
  {$EXTERNALSYM AEHLF_QUOTEWITHOUTDELIMITERS}
  AEHLF_QUOTEINCLUDE           = $4000; // Quote include string is valid.
  {$EXTERNALSYM AEHLF_QUOTEINCLUDE}
  AEHLF_QUOTEEXCLUDE           = $8000; // Quote exclude string is valid.
  {$EXTERNALSYM AEHLF_QUOTEEXCLUDE}

  //Highlight font style
  AEHLS_NONE              = 0; // Current style.
  {$EXTERNALSYM AEHLS_NONE}
  AEHLS_FONTNORMAL        = 1; // Normal style.
  {$EXTERNALSYM AEHLS_FONTNORMAL}
  AEHLS_FONTBOLD          = 2; // Bold style.
  {$EXTERNALSYM AEHLS_FONTBOLD}
  AEHLS_FONTITALIC        = 3; // Italic style.
  {$EXTERNALSYM AEHLS_FONTITALIC}
  AEHLS_FONTBOLDITALIC    = 4; // Bold italic style.
  {$EXTERNALSYM AEHLS_FONTBOLDITALIC}

  //AEM_SCROLL, AEM_LINESCROLL flags
  AESB_HORZ          = $00000001; // Horizontal scroll. Cannot be used with AESB_VERT.
  {$EXTERNALSYM AESB_HORZ}
  AESB_VERT          = $00000002; // Vertical scroll. Cannot be used with AESB_HORZ.
  {$EXTERNALSYM AESB_VERT}
  AESB_RETURNUNITS   = $00000004; // If AESB_HORZ specified, number of characters scrolled returns. If AESB_VERT specified, number of lines scrolled returns.
  {$EXTERNALSYM AESB_RETURNUNITS}
  AESB_ALIGNLEFT     = $00000008; // Align first visible char.
  {$EXTERNALSYM AESB_ALIGNLEFT}
  AESB_ALIGNRIGHT    = $00000010; // Align last visible char.
  {$EXTERNALSYM AESB_ALIGNRIGHT}
  AESB_ALIGNTOP      = $00000020; // Align first visible line.
  {$EXTERNALSYM AESB_ALIGNTOP}
  AESB_ALIGNBOTTOM   = $00000040; // Align last visible line.
  {$EXTERNALSYM AESB_ALIGNBOTTOM}

  //AEM_SCROLLCARET, AEM_SCROLLCARETTEST flags
  AESC_UNITPIXELX    = $00000001; // Low word of the lParam specifies pixels number.
  {$EXTERNALSYM AESC_UNITPIXELX}
  AESC_UNITPIXELY    = $00000002; // High word of the lParam specifies pixels number.
  {$EXTERNALSYM AESC_UNITPIXELY}
  AESC_UNITCHARX     = $00000004; // Low word of the lParam specifies characters number.
  {$EXTERNALSYM AESC_UNITCHARX}
  AESC_UNITCHARY     = $00000008; // High word of the lParam specifies characters number.
  {$EXTERNALSYM AESC_UNITCHARY}
  AESC_UNITRECTDIVX  = $00000010; // Low word of the lParam specifies divisor of the edit rectangle width.
  {$EXTERNALSYM AESC_UNITRECTDIVX}
  AESC_UNITRECTDIVY  = $00000020; // High word of the lParam specifies divisor of the edit rectangle width.
  {$EXTERNALSYM AESC_UNITRECTDIVY}
  AESC_FORCELEFT     = $00000040; // Scrolls to the left even if caret visible.
  {$EXTERNALSYM AESC_FORCELEFT}
  AESC_FORCETOP      = $00000080; // Scrolls to the top even if caret visible.
  {$EXTERNALSYM AESC_FORCETOP}
  AESC_FORCERIGHT    = $00000100; // Scrolls to the right even if caret visible.
  {$EXTERNALSYM AESC_FORCERIGHT}
  AESC_FORCEBOTTOM   = $00000200; // Scrolls to the bottom even if caret visible.
  {$EXTERNALSYM AESC_FORCEBOTTOM}

  //AEM_SCROLLCARET, AEM_SCROLLCARETTEST return flags
  AECSE_SCROLLEDX     = $00000001; // Edit control was horizontally scrolled.
  {$EXTERNALSYM AECSE_SCROLLEDX}
  AECSE_SCROLLEDY     = $00000002; // Edit control was vertically scrolled.
  {$EXTERNALSYM AECSE_SCROLLEDY}
  AECSE_SCROLLEDLEFT  = $00000004; // Edit control was scrolled left horizontally.
  {$EXTERNALSYM AECSE_SCROLLEDLEFT}
  AECSE_SCROLLEDRIGHT = $00000008; // Edit control was scrolled right horizontally.
  {$EXTERNALSYM AECSE_SCROLLEDRIGHT}
  AECSE_SCROLLEDUP    = $00000010; // Edit control was scrolled up vertically.
  {$EXTERNALSYM AECSE_SCROLLEDUP}
  AECSE_SCROLLEDDOWN  = $00000020; // Edit control was scrolled down vertically.
  {$EXTERNALSYM AECSE_SCROLLEDDOWN}

  //AEM_GETCHARSIZE flags
  AECS_HEIGHT   = 0; // Current font character height.
  {$EXTERNALSYM AECS_HEIGHT}
  AECS_AVEWIDTH = 1; // Current font character average width.
  {$EXTERNALSYM AECS_AVEWIDTH}

  //AEM_CONVERTPOINT flags
  AECPT_GLOBALTOCLIENT = 0; // Convert position in the virtual text space
                            // of the document, to client area coordinates.
  {$EXTERNALSYM AECPT_GLOBALTOCLIENT}
  AECPT_CLIENTTOGLOBAL = 1; // Convert position in the client area coordinates,
                            // to virtual text space of the document.
  {$EXTERNALSYM AECPT_CLIENTTOGLOBAL}

  //AEM_FINDTEXTA, AEM_FINDTEXTW flags
  AEFR_DOWN =      $00000001; // If set, the search is from the beginning to
                              // the end of the search range. If not set, the search
                              // is from the end to the beginning of the search range.
  {$EXTERNALSYM AEFR_DOWN}
  AEFR_WHOLEWORD = $00000002; // If set, the operation searches only for whole
                              // words that match the search string. If not set,
                              // the operation also searches for word fragments
                              // that match the search string.
  {$EXTERNALSYM AEFR_WHOLEWORD}
  AEFR_MATCHCASE = $00000004; // If set, the search operation is case-sensitive.
                              // If not set, the search operation is case-insensitive.
  {$EXTERNALSYM AEFR_MATCHCASE}

  //AEM_DRAGDROP flags
  AEDD_GETDRAGWINDOW = 1; // Return dragging window handle.
  {$EXTERNALSYM AEDD_GETDRAGWINDOW}
  AEDD_STOPDRAG      = 2; // Set stop dragging operation flag.
  {$EXTERNALSYM AEDD_STOPDRAG}

  //AEM_SETWORDWRAP flags
  AEWW_NONE          = 0; // Wrap is off.
  {$EXTERNALSYM AEWW_NONE}
  AEWW_WORD          = 1; // Wrap by words.
  {$EXTERNALSYM AEWW_WORD}
  AEWW_SYMBOL        = 2; // Wrap by symbols.
  {$EXTERNALSYM AEWW_SYMBOL}

  //AEM_SETWORDBREAK flags
  AEWB_LEFTWORDSTART  = $00000001; // Left movement is stopped, when word start is found.
  {$EXTERNALSYM AEWB_LEFTWORDSTART}
  AEWB_LEFTWORDEND    = $00000002; // Left movement is stopped, when word end is found.
  {$EXTERNALSYM AEWB_LEFTWORDEND}
  AEWB_RIGHTWORDSTART = $00000004; // Right movement is stopped, when word start is found.
  {$EXTERNALSYM AEWB_RIGHTWORDSTART}
  AEWB_RIGHTWORDEND   = $00000008; // Right movement is stopped, when word end is found.
  {$EXTERNALSYM AEWB_RIGHTWORDEND}
  AEWB_STOPSPACESTART = $00000010; // Movement is stopped, when spacing start is
                                   // found. Cannot be combined with AEWB_SKIPSPACESTART.
  {$EXTERNALSYM AEWB_STOPSPACESTART}
  AEWB_STOPSPACEEND   = $00000020; // Movement is stopped, when spacing end is found.
                                   // Cannot be combined with AEWB_SKIPSPACEEND.
  {$EXTERNALSYM AEWB_STOPSPACEEND}
  AEWB_SKIPSPACESTART = $00000040; // Movement is continued, when spacing start is
                                   // found. Cannot be combined with AEWB_STOPSPACESTART.
  {$EXTERNALSYM AEWB_SKIPSPACESTART}
  AEWB_SKIPSPACEEND   = $00000080; // Movement is continued, when spacing end is
                                   // found. Cannot be combined with AEWB_STOPSPACEEND.
  {$EXTERNALSYM AEWB_SKIPSPACEEND}
  AEWB_STOPNEWLINE    = $00000100; // Movement is stopped, when new line is found.
  {$EXTERNALSYM AEWB_STOPNEWLINE}

  //AEM_STREAMIN, AEM_STREAMOUT flags
  AESF_SELECTION      = $00000001; // Stream-in (read) or stream-out (write)
                                   // the current selection. If not specified,
                                   // stream-in (read) or stream-out (write)
                                   // the entire contents of the control.
  {$EXTERNALSYM AESF_SELECTION}
  AESF_FILLSPACES     = $00000002; // Stream-out (write) the current column
                                   // selection with the filling empty spaces.
                                   // Valid if bColumnSel member of a AESTREAMOUT
                                   // structure is TRUE.
  {$EXTERNALSYM AESF_FILLSPACES}

  FR_DOWN                 = $00000001;
  {$EXTERNALSYM FR_DOWN}
  FR_WHOLEWORD            = $00000002;
  {$EXTERNALSYM FR_WHOLEWORD}
  FR_MATCHCASE            = $00000004;
  {$EXTERNALSYM FR_MATCHCASE}
  EC_LEFTMARGIN           = $0001;
  {$EXTERNALSYM EC_LEFTMARGIN}
  EC_RIGHTMARGIN          = $0002;
  {$EXTERNALSYM EC_RIGHTMARGIN}
  GT_SELECTION            = $0002;
  {$EXTERNALSYM GT_SELECTION}
  SPI_GETWHEELSCROLLLINES = $0068;
  {$EXTERNALSYM SPI_GETWHEELSCROLLLINES}
  WC_NO_BEST_FIT_CHARS    = $00000400;
  {$EXTERNALSYM WC_NO_BEST_FIT_CHARS}
  WM_MOUSEWHEEL           = $020A;
  {$EXTERNALSYM WM_MOUSEWHEEL}
  EN_DRAGDROPDONE         = $070c;
  {$EXTERNALSYM EN_DRAGDROPDONE}
  EM_SHOWSCROLLBAR = (WM_USER + 96);
  {$EXTERNALSYM EM_SHOWSCROLLBAR}
  EM_SETTEXTEX     = (WM_USER + 97);
  {$EXTERNALSYM EM_SETTEXTEX}

  ST_DEFAULT              = $0000;
  {$EXTERNALSYM ST_DEFAULT}
  ST_KEEPUNDO             = $0001;
  {$EXTERNALSYM ST_KEEPUNDO}
  ST_SELECTION            = $0002;
  {$EXTERNALSYM ST_SELECTION}
  ST_NEWCHARS             = $0004;
  {$EXTERNALSYM ST_NEWCHARS}

type
  SETTEXTEX = record
    flags: LongInt;
    codepage: Word;
  end;
  {$EXTERNALSYM SETTEXTEX}
  TSetTextEx = SETTEXTEX;

const
  EM_GETSCROLLPOS = (WM_USER + 221);
  {$EXTERNALSYM EM_GETSCROLLPOS}
  EM_SETSCROLLPOS = (WM_USER + 222);  
  {$EXTERNALSYM EM_SETSCROLLPOS}

type
  AEStreamCallback = function(dwCookie: DWORD;  wszBuf: PWideChar;
    dwBufLen: DWORD; var dwBufDone: DWORD): DWORD; stdcall;
  //dwCookie  - Value of the dwCookie member of the AESTREAMIN or AESTREAMOUT
  //            structure. The application specifies this value when it sends
  //            the AEM_STREAMIN or AEM_STREAMOUT message.
  //wszBuf    - cPointer to a buffer to read from or write to. For a stream-in
  //            (read) operation, the callback function fills this buffer with
  //            data to transfer into the edit control. For a stream-out (write)
  //            operation, the buffer contains data from the control that the
  //            callback function writes to some storage.
  //dwBufLen  - Number of bytes to read or write.
  //dwBufDone - cPointer to a variable that the callback function sets to the
  //            number of bytes actually read or written.
  //
  //Return Value
  // The callback function returns zero to indicate success.
  //
  //Remarks
  // The control continues to call the callback function until one of the following conditions occurs:
  // * The callback function returns a nonzero value.
  // * The callback function returns zero in the *dwBufDone parameter.


// Structures

type
  HSTACK = record
    First: Integer;
    Last: Integer;
  end;
  THStack = HSTACK;
  {$EXTERNALSYM HSTACK}

  PStack = ^TStack;
  _stack = record
    Next: PStack;
    Prev: PStack;
  end;
{$EXTERNALSYM _stack}
  TStack = _stack;
  stack = _stack;
{$EXTERNALSYM stack}

  PAELineData = ^TAELineData;
  _AELINEDATA = record   
    next: PAELineData;     // cPointer to the next AELINEDATA structure.
    prev: PAELineData;     // cPointer to the previous AELINEDATA structure.
    wpLine: PWideChar;     // Text of the line, terminated with NULL character.
    nLineLen: Integer;     // Length of the wpLine, not including
                           // the terminating NULL character.
    nLineBreak: Integer;   // New line: AELB_EOF, AELB_R, AELB_N, AELB_RN,
                           // AELB_RRN or AELB_WRAP. HIWORD is free and can be used.
    nLineWidth: Integer;   // Width of the line in pixels.
    nSelStart: Integer;    // Selection start character position in line.
    nSelEnd: Integer;      // Selection end character position in line.
  end;
  {$EXTERNALSYM _AELINEDATA}
  TAELineData = _AELINEDATA;
  AELINEDATA = _AELINEDATA;
  {$EXTERNALSYM AELINEDATA}

  PAELineIndex = ^TAELineIndex;
 _AELINEINDEX = record
    nLine: integer ;       // Zero based line number in document.
    lpLine: PAELineData;   // cPointer to the AELINEDATA structure.
  end;
  {$EXTERNALSYM _AELINEINDEX}
  TAELineIndex = _AELINEINDEX;
  AELINEINDEX = _AELINEINDEX;
  {$EXTERNALSYM AELINEINDEX}

  PAECharIndex = ^TAECharIndex;
  _AECHARINDEX = record
    nLine: Integer;        // Zero based line number in document.
    lpLine: PAELineData;   // cPointer to the AELINEDATA structure.
    nCharInLine: Integer;  // Character position in line.
  end;
  {$EXTERNALSYM _AECHARINDEX}
  TAECharIndex = _AECHARINDEX;
  AECHARINDEX = _AECHARINDEX;
  {$EXTERNALSYM AECHARINDEX}

  PAECharRange = ^TAECharRange;
  AECHARRANGE = record
    ciMin: AECHARINDEX;    // First character index in range.
    ciMax: AECHARINDEX;    // Last character index in range.
  end;
  {$EXTERNALSYM AECHARINDEX}
  TAECharRange = AECHARRANGE;

  AESELECTION = record
    crSel: TAECharRange;   // Characters range.
//    bColumnSel: BOOL;      // Column selection.
    dwFlags: DWORD;        // See AESELT_* defines.
  end;
  {$EXTERNALSYM AESELECTION}
  TAESelection = AESELECTION;

  PAEPoint = ^TAEPoint;
  _AEPOINT = record
    Next: PAEPoint;        // cPointer to the next AEPOINT structure.
    Prev: PAEPoint;        // cPointer to the previous AEPOINT structure.
    ciPoint: TAECharIndex; // Character index.
    bModify: BOOL;         // Is ciPoint index modified.
    dwUserData: LongInt;   // User data.
  end;
  {$EXTERNALSYM _AEPOINT}
  TAEPoint = _AEPOINT;
  AEPOINT = _AEPOINT;
  {$EXTERNALSYM AEPOINT}

  PAEAppendTextA = ^TAEAppendTextA;
  AEAPPENDTEXTA = record
    pText: PChar;          // [in] Text to append.
    dwTextLen: LongInt;    // [in] Text length. If this value is 1, the string
                           // is assumed to be null-terminated and the length
                           // is calculated automatically.
    bColumnSel: BOOL;      // [in] Column selection.
  end;
 {$EXTERNALSYM AEAPPENDTEXTA}
  TAEAppendTextA = AEAPPENDTEXTA;

  PAEAppendTextW = ^TAEAppendTextW;
  AEAPPENDTEXTW = record
    pText: PWideChar;      // [in] Text to append.
    dwTextLen: LongInt;    // [in] Text length. If this value is 1, the string
                           // is assumed to be null-terminated and the length
                           // is calculated automatically.
    bColumnSel: BOOL;      // [in] Column selection.
  end;
 {$EXTERNALSYM AEAPPENDTEXTW}
  TAEAppendTextW = AEAPPENDTEXTW;

  PAEReplaceSelA = ^TAEReplaceSelA;
  AEREPLACESELA = record
    pText: PChar;                // [in]  Text to replace with.
    dwTextLen: DWORD;            // [in]  Text length. If this value is 1,
                                 // the string is assumed to be null-terminated
                                 // and the length is calculated automatically.
    bColumnSel: BOOL;            // [in]  Column selection.
    ciInsertStart: PAECharIndex; // [out] Insert "from" character index after replacement.
    ciInsertEnd: PAECharIndex;   // [out] Insert "to" character index after replacement.
  end;
  {$EXTERNALSYM AEREPLACESELA}
  TAEReplaceSelA = AEREPLACESELA;

  PAEReplaceSelW = ^TAEReplaceSelW;
  AEREPLACESELW = record
    pText: PwideChar;            // [in]  Text to replace with.
    dwTextLen: DWORD;            // [in]  Text length. If this value is 1,
                                 // the string is assumed to be null-terminated
                                 // and the length is calculated automatically.
    bColumnSel: BOOL;            // [in]  Column selection.
    ciInsertStart: PAECharIndex; // [out] Insert "from" character index after replacement.
    ciInsertEnd: PAECharIndex;   // [out] Insert "to" character index after replacement.
  end;
  {$EXTERNALSYM AEREPLACESELW}
  TAEReplaceSelW = AEREPLACESELW;

  PAETextRangeA = ^TAETextRangeA;
  AETEXTRANGEA = record
    cr: TAECharRange;      // [in]  Characters range to retrieve.
    bColumnSel: BOOL;      // [in]  Column selection.
    pBuffer: PChar;        // [out] cPointer to buffer that receives the text.
                           //       If this value is NULL, the function returns
                           //       the required buffer size in characters.
    dwBufferMax: DWORD;    // [in]  Specifies the maximum number of characters
                           //       to copy to the buffer, including the NULL character.
    nNewLine: Integer;     // [in]  See AELB_* defines.
    bFillSpaces: BOOL;     // [in]  If bColumnSel is TRUE, fill empties with spaces.
  end;
  {$EXTERNALSYM AETEXTRANGEA}
  TAETextRangeA = AETEXTRANGEA;

  PAETextRangeW = ^TAETextRangeW;
  AETEXTRANGEW = record
    cr: TAECharRange;      // [in]  Characters range to retrieve.
    bColumnSel: BOOL;      // [in]  Column selection.
    pBuffer: PWideChar;    // [out] cPointer to buffer that receives the text.
                           //       If this value is NULL, the function returns
                           //       the required buffer size in characters.
    dwBufferMax: DWORD;    // [in]  Specifies the maximum number of characters
                           //       to copy to the buffer, including the NULL character.
    nNewLine: Integer;     // [in]  See AELB_* defines.
    bFillSpaces: BOOL;     // [in]  If bColumnSel is TRUE, fill empties with spaces.
  end;
  {$EXTERNALSYM AETEXTRANGEW}
  TAETextRangeW = AETEXTRANGEW;

  PAEStreamIn = ^TAEStreamIn;
  AESTREAMIN = record
    dwCookie: DWORD;              // [in]  Specifies an application-defined value
                                  //       that the edit control passes to
                                  //       the AEStreamCallback function
                                  //       specified by the lpCallback member.
    dwError: DWORD;               // [out] Indicates the results of the
                                  //       stream-in (read) operation.
    lpCallback: AEStreamCallback; // [in]  cPointer to an AEStreamCallback function,
                                  //       which is an application-defined function
                                  //       that the control calls to transfer data.
                                  //       The control calls the callback
                                  //       function repeatedly, transferring
                                  //       a portion of the data with each call.
    nNewLine: Integer;            // [in]  See AELB_* defines.
    dwTextLen: DWORD;             // [in]  Text length. Need if using
                                  //       AEN_PROGRESS notification.
    nFirstNewLine: Integer;       // [out] Indicates first new line. See
                                  //       AELB_* defines.
  end;
  {$EXTERNALSYM AESTREAMIN}
  TAEStreamIn = AESTREAMIN;

  PAEStreamOut = ^TAEStreamOut;

  AESTREAMOUT = record
    dwCookie: DWORD;              // [in]  Specifies an application-defined value
                                  //       that the edit control passes to
                                  //       the AEStreamCallback function specified
                                  //       by the lpCallback member.
    dwError: DWORD;               // [out] Indicates the results of the
                                  //       stream-out (write) operation.
    lpCallback: AEStreamCallback; // [in]  cPointer to an AEStreamCallback function,
                                  //       which is an application-defined function
                                  //       that the control calls to transfer data.
                                  //       The control calls the callback function
                                  //       repeatedly, transferring a portion of
                                  //       the data with each call.
    nNewLine: Integer;            // [in]  See AELB_* defines.
    bColumnSel: BOOL;             // [in]  Column selection.
  end;
  {$EXTERNALSYM AESTREAMOUT}
  TAEStreamOut = AESTREAMOUT;

  PAEFindTextA = ^TAEFindTextA;
  AEFINDTEXTA = record
    dwFlags: DWORD;         // [in]  See AEFR_* defines.
    pText: PChar;           // [in]  Text to find.
    dwTextLen: DWORD;       // [in]  Text length. If this value is 1, the string
                            //       is assumed to be null-terminated and
                            //       the length is calculated automatically.
    nNewLine: Integer;      // [in]  See AELB_* defines.
    crSearch: TAECharRange; // [in]  Range of characters to search.
    crFound: TAECharRange;  // [out] Range of characters in which text is found.
  end;
  {$EXTERNALSYM AEFINDTEXTA}
  TAEFindTextA = AEFINDTEXTA;

  PAEFindTextW = ^TAEFindTextW;
  AEFINDTEXTW = record
    dwFlags: DWORD;         // [in]  See AEFR_* defines.
    pText: PWideChar;       // [in]  Text to find.
    dwTextLen: DWORD;       // [in]  Text length. If this value is 1, the string
                            //       is assumed to be null-terminated and
                            //       the length is calculated automatically.
    nNewLine: Integer;      // [in]  See AELB_* defines.
    crSearch: TAECharRange; // [in]  Range of characters to search.
    crFound: TAECharRange;  // [out] Range of characters in which text is found.
  end;
  {$EXTERNALSYM AEFINDTEXTW}
  TAEFindTextW = AEFINDTEXTW;

  PAEColors = ^TAEColors;
  AECOLORS = record
    dwFlags: DWORD;              // [in] See AECLR_* defines.
    crCaret: TColorRef;          // [in] Caret color.
    crBasicText: TColorRef;      // [in] Basic text color.
    crBasicBk: TColorRef;        // [in] Basic background color.
    crSelText: TColorRef;        // [in] Text color in selection.
    crSelBk: TColorRef;          // [in] Background color in selection.
    crActiveLineText: TColorRef; // [in] Text color in active line.
    crActiveLineBk: TColorRef;   // [in] Background color in active line.
    crUrlText: TColorRef;        // [in] Hiperlink text color.
    crActiveColumn: TColorRef;   // [in] Active column color.
    crColumnMarker: TColorRef;   // [in] Column marker color.
  end;
  {$EXTERNALSYM AECOLORS}
  TAEColors = AECOLORS;

  PAEIndexOffset = ^TAEIndexOffset;
  AEINDEXOFFSET = record
    ciCharIn: PAECharIndex;  // [in]  Input character index.
    ciCharOut: PAECharIndex; // [out] Output character index (result).
    nOffset: Integer;        // [in]  Offset can be positive or negative. For
                             //       example, +1 will return next character,
                             //       -1 will return previous character.
    nNewLine: Integer;       // [in]  See AELB_* defines.
  end;
  {$EXTERNALSYM AEINDEXOFFSET}
  TAEIndexOffset = AEINDEXOFFSET;

  PAEIndexSubtract = ^TAEIndexSubtract;
  AEINDEXSUBTRACT = record
    ciChar1: PAECharIndex;   // [in] First character index.
    ciChar2: PAECharIndex;   // [in] Second character index.
    bColumnSel: BOOL;        // [in] Column selection.
    nNewLine: Integer;       // [in] See AELB_* defines.
  end;
  {$EXTERNALSYM AEINDEXSUBTRACT}
  TAEIndexSubtract = AEINDEXSUBTRACT;

  PAEPrint = ^TAEPrint;
  AEPRINT = record
    dwFlags: DWORD;           // [in]     See AEPRN_* defines.
    hPrinterDC: HDC;          // [in]     Printer device context.
    hEditFont: HFONT;         // [in]     Edit font.
    hPrintFont: HFONT;        // [out]    Print font (mapped edit font).
    nCharHeight: Integer;     // [out]    Print character height.
    nAveCharWidth: Integer;   // [out]    Print character average width.
    nSpaceCharWidth: Integer; // [out]    Print space width.
    nTabWidth: Integer;       // [out]    Print tabulation width.
    rcMargins: TRect;         // [in]     Specifies the widths of the left, top,
                              //          right, and bottom margins.
                              //          The AEPRN_INHUNDREDTHSOFMILLIMETERS or
                              //          AEPRN_INTHOUSANDTHSOFINCHES flag
                              //          indicates the units of measurement.
    rcPageFull: TRect;        // [out]    Complete page rectangle. Filled by
                              //          AEM_STARTPRINTDOC message.
    rcPageIn: TRect;          // [in,out] Available page rectangle (minus margins).
                              //          Filled by AEM_STARTPRINTDOC message and
                              //          can be modified by user before
                              //          AEM_PRINTPAGE call.
    rcPageOut: TRect;         // [out]    Filled page rectangle. Filled by
                              //          AEM_PRINTPAGE message.
    crText: TAECharRange;     // [in,out] Text range to print. Filled by user and
                              //          changed after AEM_PRINTPAGE message.
  end;
  {$EXTERNALSYM AEPRINT}
  TAEPrint = AEPRINT;

  PAEDelimitemA = ^TAEDelimitemA;
  _AEDELIMITEMA = record
    next: PAEDelimitemA;
    prev: PAEDelimitemA;
    pDelimiter: PChar;      // Delimiter string.
    nDelimiterLen: Integer; // Delimiter string length.
    dwFlags: DWORD;         // See AEHLF_* defines.
    crText: TColorRef;      // Delimiter text color. If -1, then don't set.
    crBk: TColorRef;        // Delimiter background color. If -1, then don't set.
    dwFontStyle: DWORD;     // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEDELIMITEMA}
  TAEDelimitemA = _AEDELIMITEMA;
  AEDELIMITEMA = _AEDELIMITEMA;
  {$EXTERNALSYM AEDELIMITEMA}

  PAEDelimitemW = ^TAEDelimitemW;
  _AEDELIMITEMW = record
    next: PAEDelimitemW;
    prev: PAEDelimitemW;
    pDelimiter: PChar;      // Delimiter string.
    nDelimiterLen: Integer; // Delimiter string length.
    dwFlags: DWORD;         // See AEHLF_* defines.
    crText: TColorRef;      // Delimiter text color. If -1, then don't set.
    crBk: TColorRef;        // Delimiter background color. If -1, then don't set.
    dwFontStyle: DWORD;     // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEDELIMITEMW}
  TAEDelimitemW = _AEDELIMITEMW;
  AEDELIMITEMW = _AEDELIMITEMW;
  {$EXTERNALSYM AEDELIMITEMW}

 PAEWordItemA = ^TAEWordItemA;
 _AEWORDITEMA = record
    next: PAEWordItemA;
    prev: PAEWordItemA;
    pWord: PChar;           // Word string.
    nWordLen: Integer;      // Word string length.
    dwFlags: DWORD;         // See AEHLF_* defines.
    crText: TColorRef;      // Word text color. If -1, then don't set.
    crBk: TColorRef;        // Word background color. If -1, then don't set.
    dwFontStyle: DWORD;     // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEWORDITEMA}
  TAEWordItemA = _AEWORDITEMA;
  AEWORDITEMA = _AEWORDITEMA;
  {$EXTERNALSYM AEWORDITEMA}

 PAEWordItemW = ^TAEWordItemW;
 _AEWORDITEMW = record
    next: PAEWordItemW;
    prev: PAEWordItemW;
    pWord: PChar;           // Word string.
    nWordLen: Integer;      // Word string length.
    dwFlags: DWORD;         // See AEHLF_* defines.
    crText: TColorRef;      // Word text color. If -1, then don't set.
    crBk: TColorRef;        // Word background color. If -1, then don't set.
    dwFontStyle: DWORD;     // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEWORDITEMW}
  TAEWordItemW = _AEWORDITEMW;
  AEWORDITEMW = _AEWORDITEMW;
  {$EXTERNALSYM AEWORDITEMW}

  PAEQuoteItemA = ^TAEQuoteItemA;
  _AEQUOTEITEMA = record
    next: PAEQuoteItemA;
    prev: PAEQuoteItemA;
    pQuoteStart: PChar;        // Quote start string.
    nQuoteStartLen: Integer;   // Quote start string length.
    pQuoteEnd: PChar;          // Quote end string. If NULL, line end used as quote end.
    nQuoteEndLen: Integer;     // Quote end string length.
    chEscape: Char;            // Escape character. If it precedes quote string then quote ignored.
    pQuoteInclude: PChar;      // Quote include string.
    nQuoteIncludeLen: Integer; // Quote include string length.
    pQuoteExclude: PChar;      // Quote exclude string.
    nQuoteExcludeLen: Integer; // Quote exclude string length.
    dwFlags: DWORD;            // See AEHLF_* defines.
    crText: TColorRef;         // Quote text color. If -1, then don't set.
    crBk: TColorRef;           // Quote background color. If -1, then don't set.
    dwFontStyle: DWORD;        // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEQUOTEITEMA}
  TAEQuoteItemA = _AEQUOTEITEMA;
  AEQUOTEITEMA = _AEQUOTEITEMA;
  {$EXTERNALSYM AEQUOTEITEMA}

  PAEQuoteItemW = ^TAEQuoteItemW;
  _AEQUOTEITEMW = record
    next: PAEQuoteItemW;
    prev: PAEQuoteItemW;
    pQuoteStart: PChar;        // Quote start string.
    nQuoteStartLen: Integer;   // Quote start string length.
    pQuoteEnd: PChar;          // Quote end string. If NULL, line end used as quote end.
    nQuoteEndLen: Integer;     // Quote end string length.
    chEscape: Char;            // Escape character. If it precedes quote string then quote ignored.
    pQuoteInclude: PChar;      // Quote include string.
    nQuoteIncludeLen: Integer; // Quote include string length.
    pQuoteExclude: PChar;      // Quote exclude string.
    nQuoteExcludeLen: Integer; // Quote exclude string length.
    dwFlags: DWORD;            // See AEHLF_* defines.
    crText: TColorRef;         // Quote text color. If -1, then don't set.
    crBk: TColorRef;           // Quote background color. If -1, then don't set.
    dwFontStyle: DWORD;        // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEQUOTEITEMW}
  TAEQuoteItemW = _AEQUOTEITEMW;
  AEQUOTEITEMW = _AEQUOTEITEMW;
  {$EXTERNALSYM AEQUOTEITEMW}

  PAEMarkTextItemA = ^TAEMarkTextItemA;
  _AEMARKTEXTITEMA = record
    next: PAEMarkTextItemA;
    prev: PAEMarkTextItemA;
    pMarkText: PChar;          // Mark text.
    nMarkTextLen: Integer;     // Mark text length.
    dwFlags: DWORD;            // See AEHLF_* defines.
    crText: TColorRef;         // Mark text color. If -1, then don't set.
    crBk: TColorRef;           // Mark background color. If -1, then don't set.
    dwFontStyle: DWORD;        // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEMARKTEXTITEMA}
  TAEMarkTextItemA = _AEMARKTEXTITEMA;
  AEMARKTEXTITEMA = _AEMARKTEXTITEMA;
  {$EXTERNALSYM AEMARKTEXTITEMA}

  PAEMarkTextItemW = ^TAEMarkTextItemW;
  _AEMARKTEXTITEMW = record
    next: PAEMarkTextItemW;
    prev: PAEMarkTextItemW;
    pMarkText: PChar;          // Mark text.
    nMarkTextLen: Integer;     // Mark text length.
    dwFlags: DWORD;            // See AEHLF_* defines.
    crText: TColorRef;         // Mark text color. If -1, then don't set.
    crBk: TColorRef;           // Mark background color. If -1, then don't set.
    dwFontStyle: DWORD;        // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEMARKTEXTITEMW}
  TAEMarkTextItemW = _AEMARKTEXTITEMW;
  AEMARKTEXTITEMW = _AEMARKTEXTITEMW;
  {$EXTERNALSYM AEMARKTEXTITEMW}

  PAEMarkRangeItem = ^TAEMarkRangeItem;
  _AEMARKRANGEITEM = record   
    next: PAEMarkRangeItem;
    prev: PAEMarkRangeItem;
    crMarkRange: TCharRange; // cpMin member is the first character in the range 
                             // (RichEdit offset), cpMax member is the last 
                             // character in the range (RichEdit offset).
    dwFlags: DWORD;          // Reserved.
    crText: TColorRef;       // Mark text color. If -1, then don't set.
    crBk: TColorRef;         // Mark background color. If -1, then don't set.
    dwFontStyle: DWORD;      // See AEHLS_* defines.
  end;
  {$EXTERNALSYM _AEMARKRANGEITEM}
  TAEMarkRangeItem = _AEMARKRANGEITEM;
  AEMARKRANGEITEM = _AEMARKRANGEITEM;
  {$EXTERNALSYM AEMARKRANGEITEM}

  AENERRSPACE = record  
    hdr: NMHDR;
    dwBytes: DWORD;          // Number of bytes that cannot be allocated.
  end;
  {$EXTERNALSYM AENERRSPACE}
  TAENErrSpace = AENERRSPACE;
  
  AENSELCHANGE = record  
    hdr: NMHDR;
    aes: TAESelection;       // Current selection.
    ciCaret: TAECharIndex;   // Caret character index position.
  end;
  {$EXTERNALSYM AENSELCHANGE}
  TAENSelChange = AENSELCHANGE;

  AENTEXTCHANGE = record  
    hdr: NMHDR;
    aes: TAESelection;       // Current selection.
    ciCaret: TAECharIndex;   // Caret character index position.
    dwType: DWORD;           // See AETCT_* defines.
  end;
  {$EXTERNALSYM AENTEXTCHANGE}
  TAENTextChange = AENTEXTCHANGE;
  
  AENMODIFY = record  
    hdr: NMHDR;
    bModified: BOOL;         // TRUE document state is set to modified, 
                             // FALSE document state is set to unmodified.
  end;
  {$EXTERNALSYM AENMODIFY}
  TAENModify = AENMODIFY;

  AENSCROLL = record  
    hdr: NMHDR;
    nPosNew: Integer;        // Current scroll position.
    nPosOld: Integer;        // Previous scroll position.
    nPosMax: Integer;        // Maximum scroll position.
  end;
  {$EXTERNALSYM AENSCROLL}
  TAENScroll = AENSCROLL;

  AENDROPFILES = record
    hdr: NMHDR;
    hDrop: HDROP;        // Handle to the dropped files list (same as with WM_DROPFILES).
    ciChar: TAECharIndex; // Character index at which the dropped files would be inserted.
  end;
  {$EXTERNALSYM AENDROPFILES}
  TAENDropFiles = AENDROPFILES;

  AENDROPSOURCE = record  
    hdr: NMHDR;
    nAction: Integer;    // See AEDS_* defines.
    dwEffect: DWORD;     // Cursor effect: DROPEFFECT_COPY, DROPEFFECT_MOVE or DROPEFFECT_NONE.
    dwDropResult: DWORD; // Drop result, valid if nAction equal to AEDS_SOURCEEND.
  end;
  {$EXTERNALSYM AENDROPSOURCE}
  TAENDropSource = AENDROPSOURCE;

  AENDROPTARGET = record
    hdr: NMHDR;
    nAction: Integer; // See AEDT_* defines.
    pt: TPoint;       // Cursor position.
    dwEffect: DWORD;  // Cursor effect: DROPEFFECT_COPY, DROPEFFECT_MOVE or DROPEFFECT_NONE.
  end;
  {$EXTERNALSYM AENDROPTARGET}
  TAENDropTarget = AENDROPTARGET;

  AENLINK = record
    hdr: NMHDR;
    uMsg: Word;          // Mouse message: WM_LBUTTONDBLCLK, WM_LBUTTONDOWN,
                         // WM_LBUTTONUP, WM_MOUSEMOVE, WM_RBUTTONDBLCLK,
                         // WM_RBUTTONDOWN, WM_RBUTTONUP, WM_SETCURSOR.
    wParam: WPARAM;      // First parameter of a message.
    lParam: LPARAM;      // Second parameter of a message.
    crLink: AECHARRANGE; // Range of characters which contain URL text.
  end;
  {$EXTERNALSYM AENLINK}
  TAENLink = AENLINK;

  AENPROGRESS = record
    hdr: NMHDR;
    dwType: DWORD;        // See AEPGS_* defines.
    dwTimeElapsed: DWORD; // Elapsed time since action was start.
    nCurrent: Integer;    // Characters processed. Equal to zero, if first message.
    nMaximum: Integer;    // Total number of characters. Equal to nCurrent member,
                          // if last message.
  end;
  {$EXTERNALSYM AENPROGRESS}
  TAENProgress = AENPROGRESS;

//// AkelEdit functions
function AEC_IndexCompare(var ciChar1, ciChar2: TAECharIndex): integer;

// AkelEdit messages

const
  //Notifications
  AEN_ERRSPACE =            (WM_USER + 1001); 
  {$EXTERNALSYM AEN_ERRSPACE}
  AEN_SETFOCUS =            (WM_USER + 1002); 
  {$EXTERNALSYM AEN_SETFOCUS}
  AEN_KILLFOCUS =           (WM_USER + 1003); 
  {$EXTERNALSYM AEN_KILLFOCUS}
  AEN_SELCHANGING =         (WM_USER + 1004); 
  {$EXTERNALSYM AEN_SELCHANGING}
  AEN_SELCHANGED =          (WM_USER + 1005); 
  {$EXTERNALSYM AEN_SELCHANGED}
  AEN_TEXTCHANGING =        (WM_USER + 1006); 
  {$EXTERNALSYM AEN_TEXTCHANGING}
  AEN_TEXTCHANGED =         (WM_USER + 1007); 
  {$EXTERNALSYM AEN_TEXTCHANGED}
  AEN_MODIFY =              (WM_USER + 1008); 
  {$EXTERNALSYM AEN_MODIFY}
  AEN_HSCROLL =             (WM_USER + 1009); 
  {$EXTERNALSYM AEN_HSCROLL}
  AEN_VSCROLL =             (WM_USER + 1010); 
  {$EXTERNALSYM AEN_VSCROLL}
  AEN_DROPFILES =           (WM_USER + 1011); 
  {$EXTERNALSYM AEN_DROPFILES}
  AEN_DROPSOURCE =          (WM_USER + 1012); 
  {$EXTERNALSYM AEN_DROPSOURCE}
  AEN_DROPTARGET =          (WM_USER + 1013); 
  {$EXTERNALSYM AEN_DROPTARGET}
  AEN_LINK =                (WM_USER + 1014); 
  {$EXTERNALSYM AEN_LINK}
  AEN_PROGRESS =            (WM_USER + 1015);
  {$EXTERNALSYM AEN_PROGRESS}

  //Text retrieval and modification
  AEM_SETTEXTA =            (WM_USER + 2001); 
  {$EXTERNALSYM AEM_SETTEXTA}
  AEM_SETTEXTW =            (WM_USER + 2002); 
  {$EXTERNALSYM AEM_SETTEXTW}
  AEM_APPENDTEXTA =         (WM_USER + 2003); 
  {$EXTERNALSYM AEM_APPENDTEXTA}
  AEM_APPENDTEXTW =         (WM_USER + 2004); 
  {$EXTERNALSYM AEM_APPENDTEXTW}
  AEM_REPLACESELA =         (WM_USER + 2005); 
  {$EXTERNALSYM AEM_REPLACESELA}
  AEM_REPLACESELW =         (WM_USER + 2006); 
  {$EXTERNALSYM AEM_REPLACESELW}
  AEM_GETTEXTRANGEA =       (WM_USER + 2007); 
  {$EXTERNALSYM AEM_GETTEXTRANGEA}
  AEM_GETTEXTRANGEW =       (WM_USER + 2008); 
  {$EXTERNALSYM AEM_GETTEXTRANGEW}
  AEM_STREAMIN =            (WM_USER + 2009); 
  {$EXTERNALSYM AEM_STREAMIN}
  AEM_STREAMOUT =           (WM_USER + 2010); 
  {$EXTERNALSYM AEM_STREAMOUT}
  AEM_CANPASTE =            (WM_USER + 2011); 
  {$EXTERNALSYM AEM_CANPASTE}
  AEM_PASTE =               (WM_USER + 2012); 
  {$EXTERNALSYM AEM_PASTE}
  AEM_CUT =                 (WM_USER + 2013); 
  {$EXTERNALSYM AEM_CUT}
  AEM_COPY =                (WM_USER + 2014); 
  {$EXTERNALSYM AEM_COPY}
  AEM_CHECKCODEPAGE =       (WM_USER + 2015); 
  {$EXTERNALSYM AEM_CHECKCODEPAGE}
  AEM_FINDTEXTA =           (WM_USER + 2016);
  {$EXTERNALSYM AEM_FINDTEXTA}
  AEM_FINDTEXTW =           (WM_USER + 2017); 
  {$EXTERNALSYM AEM_FINDTEXTW}
  AEM_ISMATCHA =            (WM_USER + 2018); 
  {$EXTERNALSYM AEM_ISMATCHA}
  AEM_ISMATCHW =            (WM_USER + 2019); 
  {$EXTERNALSYM AEM_ISMATCHW}
  AEM_KEYDOWN =             (WM_USER + 2020); 
  {$EXTERNALSYM AEM_KEYDOWN}
  AEM_DRAGDROP =            (WM_USER + 2021); 
  {$EXTERNALSYM AEM_DRAGDROP}

  //Undo and Redo
  AEM_CANUNDO =             (WM_USER + 2051); 
  {$EXTERNALSYM AEM_CANUNDO}
  AEM_CANREDO =             (WM_USER + 2052); 
  {$EXTERNALSYM AEM_CANREDO}
  AEM_UNDO =                (WM_USER + 2053); 
  {$EXTERNALSYM AEM_UNDO}
  AEM_REDO =                (WM_USER + 2054); 
  {$EXTERNALSYM AEM_REDO}
  AEM_EMPTYUNDOBUFFER =     (WM_USER + 2055); 
  {$EXTERNALSYM AEM_EMPTYUNDOBUFFER}
  AEM_STOPGROUPTYPING =     (WM_USER + 2056); 
  {$EXTERNALSYM AEM_STOPGROUPTYPING}
  AEM_BEGINUNDOACTION =     (WM_USER + 2057); 
  {$EXTERNALSYM AEM_BEGINUNDOACTION}
  AEM_ENDUNDOACTION =       (WM_USER + 2058); 
  {$EXTERNALSYM AEM_ENDUNDOACTION}
  AEM_LOCKCOLLECTUNDO =     (WM_USER + 2059); 
  {$EXTERNALSYM AEM_LOCKCOLLECTUNDO}
  AEM_GETUNDOLIMIT =        (WM_USER + 2060); 
  {$EXTERNALSYM AEM_GETUNDOLIMIT}
  AEM_SETUNDOLIMIT =        (WM_USER + 2061); 
  {$EXTERNALSYM AEM_SETUNDOLIMIT}
  AEM_GETMODIFY =           (WM_USER + 2062); 
  {$EXTERNALSYM AEM_GETMODIFY}
  AEM_SETMODIFY =           (WM_USER + 2063); 
  {$EXTERNALSYM AEM_SETMODIFY}
  AEM_UNDOBUFFERSIZE =      (WM_USER + 2064); 
  {$EXTERNALSYM AEM_UNDOBUFFERSIZE}

  //Text coordinates
  AEM_EXGETSEL =            (WM_USER + 2099);
  {$EXTERNALSYM AEM_EXGETSEL}
  AEM_EXSETSEL =            (WM_USER + 2100);
  {$EXTERNALSYM AEM_EXSETSEL}
  AEM_GETSEL =              (WM_USER + 2101);
  {$EXTERNALSYM AEM_GETSEL}
  AEM_SETSEL =              (WM_USER + 2102);
  {$EXTERNALSYM AEM_SETSEL}
  AEM_GETCOLUMNSEL =        (WM_USER + 2103); 
  {$EXTERNALSYM AEM_GETCOLUMNSEL}
  AEM_UPDATESEL =           (WM_USER + 2104); 
  {$EXTERNALSYM AEM_UPDATESEL}
  AEM_GETLINENUMBER =       (WM_USER + 2105);
  {$EXTERNALSYM AEM_GETLINENUMBER}
  AEM_GETINDEX =            (WM_USER + 2106);
  {$EXTERNALSYM AEM_GETINDEX}
  AEM_GETLINEINDEX =        (WM_USER + 2107);
  {$EXTERNALSYM AEM_GETLINEINDEX}
  AEM_INDEXUPDATE =         (WM_USER + 2108); 
  {$EXTERNALSYM AEM_INDEXUPDATE}
  AEM_INDEXCOMPARE =        (WM_USER + 2109); 
  {$EXTERNALSYM AEM_INDEXCOMPARE}
  AEM_INDEXSUBTRACT =       (WM_USER + 2110); 
  {$EXTERNALSYM AEM_INDEXSUBTRACT}
  AEM_INDEXOFFSET =         (WM_USER + 2111); 
  {$EXTERNALSYM AEM_INDEXOFFSET}
  AEM_INDEXTORICHOFFSET =   (WM_USER + 2112); 
  {$EXTERNALSYM AEM_INDEXTORICHOFFSET}
  AEM_RICHOFFSETTOINDEX =   (WM_USER + 2113); 
  {$EXTERNALSYM AEM_RICHOFFSETTOINDEX}
  AEM_ADDPOINT =            (WM_USER + 2114); 
  {$EXTERNALSYM AEM_ADDPOINT}
  AEM_DELPOINT =            (WM_USER + 2115); 
  {$EXTERNALSYM AEM_DELPOINT}
  AEM_GETINDEXCOLUMN =      (WM_USER + 2116); 
  {$EXTERNALSYM AEM_GETINDEXCOLUMN}
  AEM_GETWRAPLINE =         (WM_USER + 2117); 
  {$EXTERNALSYM AEM_GETWRAPLINE}
  AEM_GETUNWRAPLINE =       (WM_USER + 2118); 
  {$EXTERNALSYM AEM_GETUNWRAPLINE}

  //Screen coordinates
  AEM_CHARFROMPOS =         (WM_USER + 2151); 
  {$EXTERNALSYM AEM_CHARFROMPOS}
  AEM_POSFROMCHAR =         (WM_USER + 2152); 
  {$EXTERNALSYM AEM_POSFROMCHAR}
  AEM_GETRECT =             (WM_USER + 2153); 
  {$EXTERNALSYM AEM_GETRECT}
  AEM_SETRECT =             (WM_USER + 2154); 
  {$EXTERNALSYM AEM_SETRECT}
  AEM_GETSCROLLPOS =        (WM_USER + 2155); 
  {$EXTERNALSYM AEM_GETSCROLLPOS}
  AEM_SETSCROLLPOS =        (WM_USER + 2156); 
  {$EXTERNALSYM AEM_SETSCROLLPOS}
  AEM_SCROLL =              (WM_USER + 2157);
  {$EXTERNALSYM AEM_SCROLL}
  AEM_LINESCROLL =          (WM_USER + 2158); 
  {$EXTERNALSYM AEM_LINESCROLL}
  AEM_SCROLLCARET =         (WM_USER + 2159);
  {$EXTERNALSYM AEM_SCROLLCARET}
  AEM_SCROLLCARETTEST =     (WM_USER + 2160); 
  {$EXTERNALSYM AEM_SCROLLCARETTEST}
  AEM_LOCKSCROLL =          (WM_USER + 2161);
  {$EXTERNALSYM AEM_LOCKSCROLL}
  AEM_GETERASERECT =        (WM_USER + 2162); 
  {$EXTERNALSYM AEM_GETERASERECT}
  AEM_SETERASERECT =        (WM_USER + 2163); 
  {$EXTERNALSYM AEM_SETERASERECT}
  AEM_GETCHARSIZE =         (WM_USER + 2164); 
  {$EXTERNALSYM AEM_GETCHARSIZE}
  AEM_GETSTRWIDTH =         (WM_USER + 2165); 
  {$EXTERNALSYM AEM_GETSTRWIDTH}
  AEM_GETCARETPOS =         (WM_USER + 2166); 
  {$EXTERNALSYM AEM_GETCARETPOS}
  AEM_GETCARETHORZINDENT =  (WM_USER + 2167); 
  {$EXTERNALSYM AEM_GETCARETHORZINDENT}
  AEM_SETCARETHORZINDENT =  (WM_USER + 2168); 
  {$EXTERNALSYM AEM_SETCARETHORZINDENT}
  AEM_CONVERTPOINT =        (WM_USER + 2169); 
  {$EXTERNALSYM AEM_CONVERTPOINT}

  //Options
  AEM_CONTROLCLASS =        (WM_USER + 2199); 
  {$EXTERNALSYM AEM_CONTROLCLASS}
  AEM_CONTROLVERSION =      (WM_USER + 2200); 
  {$EXTERNALSYM AEM_CONTROLVERSION}
  AEM_GETEVENTMASK =        (WM_USER + 2201); 
  {$EXTERNALSYM AEM_GETEVENTMASK}
  AEM_SETEVENTMASK =        (WM_USER + 2202); 
  {$EXTERNALSYM AEM_SETEVENTMASK}
  AEM_GETOPTIONS =          (WM_USER + 2203); 
  {$EXTERNALSYM AEM_GETOPTIONS}
  AEM_SETOPTIONS =          (WM_USER + 2204); 
  {$EXTERNALSYM AEM_SETOPTIONS}
  AEM_GETNEWLINE =          (WM_USER + 2205); 
  {$EXTERNALSYM AEM_GETNEWLINE}
  AEM_SETNEWLINE =          (WM_USER + 2206); 
  {$EXTERNALSYM AEM_SETNEWLINE}
  AEM_GETCOLORS =           (WM_USER + 2207); 
  {$EXTERNALSYM AEM_GETCOLORS}
  AEM_SETCOLORS =           (WM_USER + 2208); 
  {$EXTERNALSYM AEM_SETCOLORS}
  AEM_GETDETECTURL =        (WM_USER + 2209); 
  {$EXTERNALSYM AEM_GETDETECTURL}
  AEM_SETDETECTURL =        (WM_USER + 2210); 
  {$EXTERNALSYM AEM_SETDETECTURL}
  AEM_GETOVERTYPE =         (WM_USER + 2211); 
  {$EXTERNALSYM AEM_GETOVERTYPE}
  AEM_SETOVERTYPE =         (WM_USER + 2212); 
  {$EXTERNALSYM AEM_SETOVERTYPE}
  AEM_GETCARETWIDTH =       (WM_USER + 2213); 
  {$EXTERNALSYM AEM_GETCARETWIDTH}
  AEM_SETCARETWIDTH =       (WM_USER + 2214); 
  {$EXTERNALSYM AEM_SETCARETWIDTH}
  AEM_GETTABSTOP =          (WM_USER + 2215); 
  {$EXTERNALSYM AEM_GETTABSTOP}
  AEM_SETTABSTOP =          (WM_USER + 2216); 
  {$EXTERNALSYM AEM_SETTABSTOP}
  AEM_GETWORDWRAP =         (WM_USER + 2217); 
  {$EXTERNALSYM AEM_GETWORDWRAP}
  AEM_SETWORDWRAP =         (WM_USER + 2218); 
  {$EXTERNALSYM AEM_SETWORDWRAP}
  AEM_GETWORDDELIMITERS =   (WM_USER + 2219); 
  {$EXTERNALSYM AEM_GETWORDDELIMITERS}
  AEM_SETWORDDELIMITERS =   (WM_USER + 2220); 
  {$EXTERNALSYM AEM_SETWORDDELIMITERS}
  AEM_GETWRAPDELIMITERS =   (WM_USER + 2221); 
  {$EXTERNALSYM AEM_GETWRAPDELIMITERS}
  AEM_SETWRAPDELIMITERS =   (WM_USER + 2222); 
  {$EXTERNALSYM AEM_SETWRAPDELIMITERS}
  AEM_GETURLDELIMITERS =    (WM_USER + 2223); 
  {$EXTERNALSYM AEM_GETURLDELIMITERS}
  AEM_SETURLDELIMITERS =    (WM_USER + 2224); 
  {$EXTERNALSYM AEM_SETURLDELIMITERS}
  AEM_GETURLPREFIXES =      (WM_USER + 2225); 
  {$EXTERNALSYM AEM_GETURLPREFIXES}
  AEM_SETURLPREFIXES =      (WM_USER + 2226); 
  {$EXTERNALSYM AEM_SETURLPREFIXES}
  AEM_GETURLMAXLENGTH =     (WM_USER + 2227); 
  {$EXTERNALSYM AEM_GETURLMAXLENGTH}
  AEM_SETURLMAXLENGTH =     (WM_USER + 2228); 
  {$EXTERNALSYM AEM_SETURLMAXLENGTH}
  AEM_GETWORDBREAK =        (WM_USER + 2229); 
  {$EXTERNALSYM AEM_GETWORDBREAK}
  AEM_SETWORDBREAK =        (WM_USER + 2230); 
  {$EXTERNALSYM AEM_SETWORDBREAK}
  AEM_GETMARKER =           (WM_USER + 2231); 
  {$EXTERNALSYM AEM_GETMARKER}
  AEM_SETMARKER =           (WM_USER + 2232); 
  {$EXTERNALSYM AEM_SETMARKER}
  AEM_GETLINEGAP =          (WM_USER + 2233); 
  {$EXTERNALSYM AEM_GETLINEGAP}
  AEM_SETLINEGAP =          (WM_USER + 2234); 
  {$EXTERNALSYM AEM_SETLINEGAP}

  //Other
  AEM_ISDELIMITER =         (WM_USER + 2251); 
  {$EXTERNALSYM AEM_ISDELIMITER}
  AEM_SHOWSCROLLBAR =       (WM_USER + 2252); 
  {$EXTERNALSYM AEM_SHOWSCROLLBAR}
  AEM_UPDATESCROLLBAR =     (WM_USER + 2253); 
  {$EXTERNALSYM AEM_UPDATESCROLLBAR}
  AEM_HIDESELECTION =       (WM_USER + 2254); 
  {$EXTERNALSYM AEM_HIDESELECTION}
  AEM_ADDCLONE =            (WM_USER + 2255); 
  {$EXTERNALSYM AEM_ADDCLONE}
  AEM_DELCLONE =            (WM_USER + 2256); 
  {$EXTERNALSYM AEM_DELCLONE}
  AEM_GETMASTER =           (WM_USER + 2257); 
  {$EXTERNALSYM AEM_GETMASTER}
  AEM_GETCLONE =            (WM_USER + 2258); 
  {$EXTERNALSYM AEM_GETCLONE}

  //Print
  AEM_STARTPRINTDOC =       (WM_USER + 2451); 
  {$EXTERNALSYM AEM_STARTPRINTDOC}
  AEM_PRINTPAGE =           (WM_USER + 2452); 
  {$EXTERNALSYM AEM_PRINTPAGE}
  AEM_ENDPRINTDOC =         (WM_USER + 2453); 
  {$EXTERNALSYM AEM_ENDPRINTDOC}

  //Highlight
  AEM_HLCREATETHEMEA =      (WM_USER + 2501); 
  {$EXTERNALSYM AEM_HLCREATETHEMEA}
  AEM_HLCREATETHEMEW =      (WM_USER + 2502); 
  {$EXTERNALSYM AEM_HLCREATETHEMEW}
  AEM_HLGETTHEMEA =         (WM_USER + 2503); 
  {$EXTERNALSYM AEM_HLGETTHEMEA}
  AEM_HLGETTHEMEW =         (WM_USER + 2504); 
  {$EXTERNALSYM AEM_HLGETTHEMEW}
  AEM_HLGETTHEMENAMEA =     (WM_USER + 2505); 
  {$EXTERNALSYM AEM_HLGETTHEMENAMEA}
  AEM_HLGETTHEMENAMEW =     (WM_USER + 2506); 
  {$EXTERNALSYM AEM_HLGETTHEMENAMEW}
  AEM_HLTHEMEEXISTS =       (WM_USER + 2507); 
  {$EXTERNALSYM AEM_HLTHEMEEXISTS}
  AEM_HLSETTHEME =          (WM_USER + 2508); 
  {$EXTERNALSYM AEM_HLSETTHEME}
  AEM_HLDELETETHEME =       (WM_USER + 2509); 
  {$EXTERNALSYM AEM_HLDELETETHEME}
  AEM_HLADDDELIMITERA =     (WM_USER + 2521); 
  {$EXTERNALSYM AEM_HLADDDELIMITERA}
  AEM_HLADDDELIMITERW =     (WM_USER + 2522); 
  {$EXTERNALSYM AEM_HLADDDELIMITERW}
  AEM_HLDELETEDELIMITER =   (WM_USER + 2523); 
  {$EXTERNALSYM AEM_HLDELETEDELIMITER}
  AEM_HLADDWORDA =          (WM_USER + 2531); 
  {$EXTERNALSYM AEM_HLADDWORDA}
  AEM_HLADDWORDW =          (WM_USER + 2532); 
  {$EXTERNALSYM AEM_HLADDWORDW}
  AEM_HLDELETEWORD =        (WM_USER + 2533); 
  {$EXTERNALSYM AEM_HLDELETEWORD}
  AEM_HLADDQUOTEA =         (WM_USER + 2541); 
  {$EXTERNALSYM AEM_HLADDQUOTEA}
  AEM_HLADDQUOTEW =         (WM_USER + 2542); 
  {$EXTERNALSYM AEM_HLADDQUOTEW}
  AEM_HLDELETEQUOTE =       (WM_USER + 2543); 
  {$EXTERNALSYM AEM_HLDELETEQUOTE}
  AEM_HLADDMARKTEXTA =      (WM_USER + 2551); 
  {$EXTERNALSYM AEM_HLADDMARKTEXTA}
  AEM_HLADDMARKTEXTW =      (WM_USER + 2552); 
  {$EXTERNALSYM AEM_HLADDMARKTEXTW}
  AEM_HLDELETEMARKTEXT =    (WM_USER + 2553); 
  {$EXTERNALSYM AEM_HLDELETEMARKTEXT}
  AEM_HLADDMARKRANGE =      (WM_USER + 2561); 
  {$EXTERNALSYM AEM_HLADDMARKRANGE}
  AEM_HLDELETEMARKRANGE =   (WM_USER + 2562); 
  {$EXTERNALSYM AEM_HLDELETEMARKRANGE}

// RichEdit messages

(*
AkelEdit can emulate RichEdit 3.0 and support the following messages:

EN_CHANGE
EN_DRAGDROPDONE
EN_DROPFILES
EN_ERRSPACE
EN_HSCROLL
EN_KILLFOCUS
EN_LINK
EN_MSGFILTER
EN_SELCHANGE
EN_SETFOCUS
EN_VSCROLL

EM_AUTOURLDETECT
EM_CANPASTE
EM_CANREDO
EM_CANUNDO
EM_CHARFROMPOS
EM_EMPTYUNDOBUFFER
EM_EXGETSEL
EM_EXLINEFROMCHAR - SendMessage(hWnd, EM_EXLINEFROMCHAR, 0, -1)   ,    .
EM_EXSETSEL
EM_FINDTEXT
EM_FINDTEXTEX
EM_FINDTEXTEXW
EM_FINDTEXTW
EM_FINDWORDBREAK
EM_GETAUTOURLDETECT
EM_GETEVENTMASK
EM_GETFIRSTVISIBLELINE
EM_GETLINE
EM_GETLINECOUNT
EM_GETMARGINS
EM_GETMODIFY
EM_GETOPTIONS
EM_GETRECT
EM_GETSCROLLPOS
EM_GETSEL
EM_GETSELTEXT
EM_GETTEXTEX
EM_GETTEXTLENGTHEX
EM_GETTEXTRANGE
EM_GETTHUMB
EM_HIDESELECTION
EM_LINEFROMCHAR
EM_LINEINDEX
EM_LINELENGTH
EM_LINESCROLL
EM_POSFROMCHAR
EM_REDO
EM_REPLACESEL
EM_SCROLL
EM_SCROLLCARET
EM_SETBKGNDCOLOR
EM_SETEVENTMASK
EM_SETMARGINS
EM_SETMODIFY
EM_SETOPTIONS
EM_SETREADONLY
EM_SETRECT
EM_SETRECTNP
EM_SETSCROLLPOS
EM_SETSEL
EM_SETTEXTEX
EM_SETUNDOLIMIT
EM_SHOWSCROLLBAR
EM_STOPGROUPTYPING
EM_STREAMIN
EM_STREAMOUT
EM_UNDO
*)

//// AkelEdit messages description
//
//  AEN_ERRSPACE
//  ____________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when an edit control cannot allocate enough memory.
//  
//  (int)wParam           == specifies the control identifier.
//  (AENERRSPACE *)lParam == pointer to a AENERRSPACE structure.
//  
//  Return Value
//   zero
//  
//  
//  AEN_SETFOCUS
//  ____________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when an edit control receives the keyboard focus.
//  
//  (int)wParam     == specifies the control identifier.
//  (NMHDR *)lParam == pointer to a NMHDR structure.
//  
//  Return Value
//   zero
//  
//  
//  AEN_KILLFOCUS
//  _____________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when an edit control loses the keyboard focus.
//  
//  (int)wParam     == specifies the control identifier.
//  (NMHDR *)lParam == pointer to a NMHDR structure.
//  
//  Return Value
//   zero
//  
//  
//  AEN_SELCHANGING
//  _______________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure before the current selection has changed.
//  
//  (int)wParam            == specifies the control identifier.
//  (AENSELCHANGE *)lParam == pointer to a AENSELCHANGE structure.
//  
//  Return Value
//   zero
//  
//  Remarks
//   To receive AEN_SELCHANGING notifications, specify AENM_SELCHANGE in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_SELCHANGED
//  ______________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure after the current selection has changed.
//  
//  (int)wParam            == specifies the control identifier.
//  (AENSELCHANGE *)lParam == pointer to a AENSELCHANGE structure.
//  
//  Return Value
//   zero
//  
//  Remarks
//   To receive AEN_SELCHANGED notifications, specify AENM_SELCHANGE in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_TEXTCHANGING
//  ________________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure before the document text has changed.
//  
//  (int)wParam             == specifies the control identifier.
//  (AENTEXTCHANGE *)lParam == pointer to a AENTEXTCHANGE structure.
//  
//  Return Value
//   zero
//
//  Remarks
//   To receive AEN_TEXTCHANGING notifications, specify AENM_TEXTCHANGE in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_TEXTCHANGED
//  _______________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure after the document text has changed.
//  
//  (int)wParam             == specifies the control identifier.
//  (AENTEXTCHANGE *)lParam == pointer to a AENTEXTCHANGE structure.
//  
//  Return Value
//   zero
//  
//  Remarks
//   To receive AEN_TEXTCHANGED notifications, specify AENM_TEXTCHANGE in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_MODIFY
//  __________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure after the document modify state has changed.
//  
//  (int)wParam         == specifies the control identifier.
//  (AENMODIFY *)lParam == pointer to a AENMODIFY structure.
//  
//  Return Value
//   zero
//  
//  Remarks
//   To receive AEN_MODIFY notifications, specify AENM_MODIFY in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_HSCROLL
//  ___________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure before an edit control window scrolled horizontally.
//  
//  (int)wParam         == specifies the control identifier.
//  (AENSCROLL *)lParam == pointer to a AENSCROLL structure.
//  
//  Return Value
//   If zero, the control allows scroll operation.
//   If a nonzero value, the control suppress scroll operation.
//  
//  Remarks
//   To receive AEN_HSCROLL notifications, specify AENM_SCROLL in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_VSCROLL
//  ___________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure before an edit control window scrolled horizontally.
//  
//  (int)wParam         == specifies the control identifier.
//  (AENSCROLL *)lParam == pointer to a AENSCROLL structure.
//  
//  Return Value
//   If zero, the control allows scroll operation.
//   If a nonzero value, the control suppress scroll operation.
//  
//  Remarks
//   To receive AEN_VSCROLL notifications, specify AENM_SCROLL in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_DROPFILES
//  _____________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when the user is attempting to drop files into the control (when it receives the WM_DROPFILES message).
//  
//  (int)wParam            == specifies the control identifier.
//  (AENDROPFILES *)lParam == pointer to a AENDROPFILES structure.
//  
//  Return Value
//   If zero, the control ignores the drop operation.
//   If a nonzero value, the control allows the drop operation.
//  
//  Remarks
//   To receive AEN_DROPFILES notifications, specify AENM_DROPFILES in the mask sent with the AEM_SETEVENTMASK message.
//   To receive WM_DROPFILES messages, the parent window must register the control as a drop target by using the DragAcceptFiles function. The control does not register itself.
//  
//  
//  AEN_DROPSOURCE
//  ______________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when the user is dragging the selection.
//  
//  (int)wParam             == specifies the control identifier.
//  (AENDROPSOURCE *)lParam == pointer to a AENDROPSOURCE structure.
//  
//  Return Value
//   If zero, the control ignores the drop operation.
//   If a nonzero value, the control allows the drop operation.
//  
//  Remarks
//   To receive AEN_DROPSOURCE notifications, specify AEN_DRAGDROP in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_DROPTARGET
//  ______________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when the user is attempting to drop data into the control.
//  
//  (int)wParam             == specifies the control identifier.
//  (AENDROPTARGET *)lParam == pointer to a AENDROPTARGET structure.
//  
//  Return Value
//   If zero, the control ignores the drop operation.
//   If a nonzero value, the control allows the drop operation.
//  
//  Remarks
//   To receive AEN_DROPTARGET notifications, specify AEN_DRAGDROP in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEN_LINK
//  ________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when edit control receives mouse messages while the mouse pointer is over URL.
//  
//  (int)wParam       == specifies the control identifier.
//  (AENLINK *)lParam == pointer to a AENLINK structure.
//  
//  Return Value
//   If zero, the control proceeds with its normal handling of the mouse message.
//   If a nonzero value, the control does not handle the mouse message.
//  
//  Remarks
//   To receive AEN_LINK notifications, specify AENM_LINK in the mask sent with the AEM_SETEVENTMASK message and turn on URL detection with the AEM_SETDETECTURL message.
//  
//  
//  AEN_PROGRESS
//  ____________
//  
//  Notification message sends in the form of a WM_NOTIFY message.
//  Sends to the parent window procedure when required number of lines was proceed.
//  
//  (int)wParam           == specifies the control identifier.
//  (AENPROGRESS *)lParam == pointer to a AENPROGRESS structure.
//  
//  Return Value
//   If zero, the control continues operation.
//   If a nonzero value, the control stops operation.
//  
//  Remarks
//   To receive AEN_PROGRESS notifications, specify AENM_PROGRESS in the mask sent with the AEM_SETEVENTMASK message.
//  
//  
//  AEM_SETTEXTA
//  ____________
//  
//  Set ansi text of the edit control.
//  
//  (DWORD)wParam  == text length. If this value is 1, the string is assumed to be null-terminated and the length is calculated automatically.
//  (char *)lParam == text pointer.
//  
//  Return Value
//   Text length.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETTEXTA, (WPARAM)-1, (LPARAM)"SomeText");
//  
//  
//  AEM_SETTEXTW
//  ____________
//  
//  Set unicode text of the edit control.
//  
//  (DWORD)wParam     == text length. If this value is 1, the string is assumed to be null-terminated and the length is calculated automatically.
//  (wchar_t *)lParam == text pointer.
//  
//  Return Value
//   Text length.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETTEXTW, (WPARAM)-1, (LPARAM)L"SomeText");
//  
//  
//  AEM_APPENDTEXTA
//  _______________
//  
//  Append ansi text to the end of the edit control.
//  
//  wParam                  == not used.
//  (AEAPPENDTEXTA *)lParam == pointer to a AEAPPENDTEXTA structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AEAPPENDTEXTA at;
//  
//   at.pText="SomeText";
//   at.dwTextLen=(DWORD)-1;
//   at.bColumnSel=FALSE;
//   SendMessage(hWndEdit, AEM_APPENDTEXTA, 0, (LPARAM)&at);
//  
//  
//  AEM_APPENDTEXTW
//  _______________
//  
//  Append unicode text to the end of the edit control.
//  
//  wParam                  == not used.
//  (AEAPPENDTEXTW *)lParam == pointer to a AEAPPENDTEXTW structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AEAPPENDTEXTW at;
//  
//   at.pText=L"SomeText";
//   at.dwTextLen=(DWORD)-1;
//   at.bColumnSel=FALSE;
//   SendMessage(hWndEdit, AEM_APPENDTEXTW, 0, (LPARAM)&at);
//  
//  
//  AEM_REPLACESELA
//  _______________
//  
//  Replace selection with the ansi text.
//  
//  wParam                  == not used.
//  (AEREPLACESELA *)lParam == pointer to a AEREPLACESELA structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AEREPLACESELA rs;
//  
//   rs.pText="SomeText";
//   rs.dwTextLen=(DWORD)-1;
//   rs.bColumnSel=SendMessage(hWndEdit, AEM_GETCOLUMNSEL, 0, 0);
//   rs.ciInsertStart=NULL;
//   rs.ciInsertEnd=NULL;
//   SendMessage(hWndEdit, AEM_REPLACESELA, 0, (LPARAM)&rs);
//  
//  
//  AEM_REPLACESELW
//  _______________
//  
//  Replace selection with the unicode text.
//  
//  wParam                  == not used.
//  (AEREPLACESELW *)lParam == pointer to a AEREPLACESELW structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AEREPLACESELW rs;
//  
//   rs.pText=L"SomeText";
//   rs.dwTextLen=(DWORD)-1;
//   rs.bColumnSel=SendMessage(hWndEdit, AEM_GETCOLUMNSEL, 0, 0);
//   rs.ciInsertStart=NULL;
//   rs.ciInsertEnd=NULL;
//   SendMessage(hWndEdit, AEM_REPLACESELW, 0, (LPARAM)&rs);
//  
//  
//  AEM_GETTEXTRANGEA
//  _________________
//  
//     ansi-   

//  wParam                 == not used.
//  (AETEXTRANGEA *)lParam == pointer to a AETEXTRANGEA structure.
//
//   
//         .
//
//  :
//   AETEXTRANGEA tr;
//   int nLen;
//
//   SendMessage(hWndEdit, AEM_GETSEL, (WPARAM)NULL, (LPARAM)&tr);
//   tr.pText=NULL;
//   tr.nNewLine=AELB_ASOUTPUT;
//   tr.bFillSpaces=FALSE;
//  
//   if (nLen=SendMessage(hWndEdit, AEM_GETTEXTRANGEA, 0, (LPARAM)&tr))
//   {
//     if (tr.pText=(char *)GlobalAlloc(GPTR, nLen + 1))
//     {
//       SendMessage(hWndEdit, AEM_GETTEXTRANGEA, 0, (LPARAM)&tr);
//       MessageBoxA(NULL, tr.pText, NULL, 0);
//  
//       GlobalFree((HGLOBAL)tr.pText);
//     }
//   }
//
//  
//  AEM_GETTEXTRANGEW
//  _________________
//  
//  Retrieve a specified range of unicode characters from an edit control.
//  
//  wParam                 == not used.
//  (AETEXTRANGEW *)lParam == pointer to a AETEXTRANGEW structure.
//  
//  Return Value
//   Number of characters copied, not including the terminating NULL character.
//  
//  Example:
//   AETEXTRANGEW tr;
//   int nLen;
//  
//   SendMessage(hWndEdit, AEM_GETSEL, (WPARAM)NULL, (LPARAM)&tr);
//   tr.pText=NULL;
//   tr.nNewLine=AELB_ASOUTPUT;
//   tr.bFillSpaces=FALSE;
//  
//   if (nLen=SendMessage(hWndEdit, AEM_GETTEXTRANGEW, 0, (LPARAM)&tr))
//   {
//     if (tr.pText=(wchar_t *)GlobalAlloc(GPTR, nLen * sizeof(wchar_t) + 2))
//     {
//       SendMessage(hWndEdit, AEM_GETTEXTRANGEW, 0, (LPARAM)&tr);
//       MessageBoxW(NULL, tr.pText, NULL, 0);
//  
//       GlobalFree((HGLOBAL)tr.pText);
//     }
//   }
//  
//  
//  AEM_STREAMIN
//  ____________
//  
//  Replace the contents of an edit control with a stream of data provided by an application defined callback function.
//  
//  (DWORD)wParam        == see AESF_* defines.
//  (AESTREAMIN *)lParam == pointer to a AESTREAMIN structure.
//  
//  Return Value
//   Number of characters read.
//  
//  Example:
//   typedef struct {
//     wchar_t *wpData;
//     int nDataLen;
//     int nCount;
//   } STREAMINDATA;
//  
//   AESTREAMIN aesi;
//   STREAMINDATA sid;
//  
//   sid.wpData=L"SomeText";
//   sid.nDataLen=lstrlenW(sid.wpData);
//   sid.nCount=0;
//  
//   aesi.dwCookie=(DWORD)&sid;
//   aesi.lpCallback=InputStreamCallback;
//   aesi.nNewLine=AELB_ASINPUT;
//   aesi.dwTextLen=sid.nDataLen;
//   SendMessage(hWndEdit, AEM_STREAMIN, AESF_SELECTION, (LPARAM)&aesi);
//  
//   DWORD CALLBACK InputStreamCallback(DWORD dwCookie, wchar_t *wszBuf, DWORD dwBufLen, DWORD *dwBufDone)
//   {
//     STREAMINDATA *lpData=(STREAMINDATA *)dwCookie;
//     wchar_t *wpSrc=lpData->wpData;
//     wchar_t *wpDest=wszBuf;
//     DWORD dwDestLen=dwBufLen / sizeof(wchar_t);
//     DWORD i;
//  
//     for (i=0; i < dwDestLen; ++i)
//     {
//       if (lpData->nCount >= lpData->nDataLen)
//         break;
//       wpDest[i]=wpSrc[lpData->nCount++];
//     }
//     *dwBufDone=i * sizeof(wchar_t);
//  
//     return 0;
//   }
//  
//  
//  AEM_STREAMOUT
//  _____________
//  
//  Cause an edit control to pass its contents to an application defined callback function.
//  The callback function can then write the stream of data to a file or any other location that it chooses.
//  
//  (DWORD)wParam         == see AESF_* defines.
//  (AESTREAMOUT *)lParam == pointer to a AESTREAMOUT structure.
//  
//  Return Value
//   Number of characters written to the data stream.
//  
//  Example:
//   typedef struct {
//     HANDLE hFile;
//   } STREAMOUTDATA;
//  
//   AESTREAMOUT aeso;
//   STREAMOUTDATA sod;
//  
//   sod.hFile=CreateFileA("C:\\Test.tmp", GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
//  
//   if (sod.hFile != INVALID_HANDLE_VALUE)
//   {
//     aeso.dwCookie=(DWORD)&sod;
//     aeso.lpCallback=OutputStreamCallback;
//     aeso.nNewLine=AELB_ASOUTPUT;
//     aeso.bColumnSel=FALSE;
//     SendMessage(hWndEdit, AEM_STREAMOUT, 0, (LPARAM)&aeso);
//  
//     CloseHandle(sod.hFile);
//   }
//  
//   DWORD CALLBACK OutputStreamCallback(DWORD dwCookie, wchar_t *wszBuf, DWORD dwBufLen, DWORD *dwBufDone)
//   {
//     STREAMOUTDATA *lpData=(STREAMOUTDATA *)dwCookie;
//     unsigned char *pDataToWrite=(unsigned char *)wszBuf;
//     DWORD dwBytesToWrite=dwBufLen;
//  
//     return !WriteFile(lpData->hFile, pDataToWrite, dwBytesToWrite, dwBufDone, NULL);
//   }
//  
//  
//  AEM_CANPASTE
//  ____________
//  
//  Determine whether an edit control can paste a text from clipboard.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CANPASTE, 0, 0);
//  
//  
//  AEM_PASTE
//  _________
//  
//  Paste text from clipboard.
//  
//  wParam       == not used.
//  (BOOL)lParam == TRUE   paste as ANSI text.
//                  FALSE  paste as Unicode text, if no Unicode text available ANSI text will be used (default).
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_PASTE, 0, FALSE);
//  
//  
//  AEM_CUT
//  _______
//  
//  Delete the current selection, if any, and copy the deleted text to the clipboard.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CUT, 0, 0);
//  
//  
//  AEM_COPY
//  ________
//  
//  Copy the current selection to the clipboard.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_COPY, 0, 0);
//  
//  
//  AEM_CHECKCODEPAGE
//  _________________
//  
//  Check that the contents of an edit control can be converted to the specified code page.
//  
//  (int)wParam == code page to check.
//  lParam      == not used.
//  
//  Return Value
//   Zero if successful, otherwise returns first met line number containing nonconverted character.
//  
//  Remarks
//   Windows 95 isn't supported.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CHECKCODEPAGE, 1251, 0);
//  
//  
//  AEM_FINDTEXTA
//  _____________
//  
//  Find ansi text within an edit control.
//  
//  wParam                == not used.
//  (AEFINDTEXTA *)lParam == pointer to a AEFINDTEXTA structure.
//  
//  Return Value
//   TRUE   founded.
//   FALSE  not found.
//  
//  Example:
//   AEFINDTEXTA ft;
//   AESELECTION aes;
//  
//   ft.dwFlags=AEFR_DOWN;
//   ft.pText="SomeText";
//   ft.dwTextLen=(DWORD)-1;
//   ft.nNewLine=AELB_ASIS;
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&ft.crSearch.ciMin);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&ft.crSearch.ciMax);
//  
//   if (SendMessage(hWndEdit, AEM_FINDTEXTA, 0, (LPARAM)&ft))
//   {
//     aes.crSel=ft.crFound;
//     aes.dwFlags=0;
//     SendMessage(hWndEdit, AEM_SETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   }
//  
//  
//  AEM_FINDTEXTW
//  _____________
//  
//  Find unicode text within an edit control.
//  
//  wParam                == not used.
//  (AEFINDTEXTW *)lParam == pointer to a AEFINDTEXTW structure.
//  
//  Return Value
//   TRUE   founded.
//   FALSE  not found.
//  
//  Example:
//   AEFINDTEXTW ft;
//   AESELECTION aes;
//  
//   ft.dwFlags=AEFR_DOWN;
//   ft.pText=L"SomeText";
//   ft.dwTextLen=(DWORD)-1;
//   ft.nNewLine=AELB_ASIS;
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&ft.crSearch.ciMin);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&ft.crSearch.ciMax);
//  
//   if (SendMessage(hWndEdit, AEM_FINDTEXTW, 0, (LPARAM)&ft))
//   {
//     aes.crSel=ft.crFound;
//     aes.dwFlags=0;
//     SendMessage(hWndEdit, AEM_SETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   }
//  
//  
//  AEM_ISMATCHA
//  ____________
//  
//  Is ansi text matched with text at specified position.
//  
//  (AECHARINDEX *)wParam == position to check from.
//  (AEFINDTEXTA *)lParam == pointer to a AEFINDTEXTA structure.
//  
//  Return Value
//   Length of the matched text or zero if not found.
//  
//  Example:
//   AEFINDTEXTA ft;
//   AECHARINDEX ciChar;
//   AESELECTION aes;
//  
//   ft.dwFlags=AEFR_MATCHCASE;
//   ft.pText="SomeText";
//   ft.dwTextLen=(DWORD)-1;
//   ft.nNewLine=AELB_ASIS;
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTSELCHAR, (LPARAM)&ciChar);
//  
//   if (SendMessage(hWndEdit, AEM_ISMATCHA, (WPARAM)&ciChar, (LPARAM)&ft))
//   {
//     aes.crSel=ft.crFound;
//     aes.dwFlags=0;
//     SendMessage(hWndEdit, AEM_SETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   }
//  
//  
//  AEM_ISMATCHW
//  ____________
//  
//  Is unicode text matched with text at specified position.
//  
//  (AECHARINDEX *)wParam == position to check from.
//  (AEFINDTEXTW *)lParam == pointer to a AEFINDTEXTW structure.
//  
//  Return Value
//   Length of the matched text or zero if not found.
//  
//  Example:
//   AEFINDTEXTW ft;
//   AECHARINDEX ciChar;
//   AESELECTION aes;
//  
//   ft.dwFlags=AEFR_MATCHCASE;
//   ft.pText=L"SomeText";
//   ft.dwTextLen=(DWORD)-1;
//   ft.nNewLine=AELB_ASIS;
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTSELCHAR, (LPARAM)&ciChar);
//  
//   if (SendMessage(hWndEdit, AEM_ISMATCHW, (WPARAM)&ciChar, (LPARAM)&ft))
//   {
//     aes.crSel=ft.crFound;
//     aes.dwFlags=0;
//     SendMessage(hWndEdit, AEM_SETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   }
//  
//  
//  AEM_KEYDOWN
//  ___________
//  
//  Emulate key down pressing.
//  
//  (int)wParam   == virtual-key code.
//  (DWORD)lParam == see AEMOD_* defines.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_KEYDOWN, VK_RIGHT, AEMOD_SHIFT|AEMOD_CONTROL);
//
//  
//  AEM_DRAGDROP
//  ____________
//  
//  Operations with current drag'n'drop.
//  
//  (DWORD)wParam == see AEDD_* defines.
//  lParam        == not used.
//  
//  Return Value
//   Value depended on the AEDD_* define.
//  
//  Example:
//   HWND hWndDragSource;
//  
//   hWndDragSource=(HWND)SendMessage(hWndEdit, AEM_DRAGDROP, AEDD_GETDRAGWINDOW, 0);
//  
//  
//  AEM_CANUNDO
//  ___________
//  
//  Determine whether there are any actions in an edit control's undo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CANUNDO, 0, 0);
//  
//  
//  AEM_CANREDO
//  ___________
//  
//  Determine whether there are any actions in an edit control's redo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CANREDO, 0, 0);
//  
//  
//  AEM_UNDO
//  ________
//  
//  Undo the last edit control operation in the control's undo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_UNDO, 0, 0);
//  
//  
//  AEM_REDO
//  ________
//  
//  Redo the next edit control operation in the control's redo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_REDO, 0, 0);
//  
//  
//  AEM_EMPTYUNDOBUFFER
//  ___________________
//  
//  Erase undo and redo history.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_EMPTYUNDOBUFFER, 0, 0);
//  
//  
//  AEM_STOPGROUPTYPING
//  ___________________
//  
//  Stops the control from collecting additional typing actions into the current undo action.
//  The control stores the next typing action, if any, into a new action in the undo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_STOPGROUPTYPING, 0, 0);
//  
//  
//  AEM_BEGINUNDOACTION
//  ___________________
//  
//  Beginning of a set of operations that will be undone all as one operation.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_STOPGROUPTYPING, 0, 0);
//   SendMessage(hWndEdit, AEM_BEGINUNDOACTION, 0, 0);
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"123");
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"456");
//   SendMessage(hWndEdit, AEM_ENDUNDOACTION, 0, 0);
//   SendMessage(hWndEdit, AEM_STOPGROUPTYPING, 0, 0);
//  
//  
//  AEM_ENDUNDOACTION
//  _________________
//  
//  End of a set of operations that will be undone all as one operation.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   See AEM_BEGINUNDOACTION example.
//  
//  
//  AEM_LOCKCOLLECTUNDO
//  ___________________
//  
//  Stop collect undo/redo history.
//  
//  (BOOL)wParam == TRUE   stop collect
//                  FALSE  start collect
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_EMPTYUNDOBUFFER, 0, 0);
//   SendMessage(hWndEdit, AEM_LOCKCOLLECTUNDO, TRUE, 0);
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"123");
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"456");
//   SendMessage(hWndEdit, AEM_LOCKCOLLECTUNDO, FALSE, 0);
//  
//  
//  AEM_GETUNDOLIMIT
//  ________________
//  
//  Get the maximum number of actions that can stored in the undo queue.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Maximum number of actions that can be stored in the undo queue.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETUNDOLIMIT, 0, 0);
//  
//  
//  AEM_SETUNDOLIMIT
//  ________________
//  
//  Set the maximum number of actions that can stored in the undo queue.
//  
//  (DWORD)wParam == maximum number of actions that can be stored in the undo queue. By default, the maximum number of actions in the undo queue is unlimited.
//  lParam        == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETUNDOLIMIT, 100, 0);
//  
//  
//  AEM_GETMODIFY
//  _____________
//  
//  Retrieve the state of an edit control's modification flag.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   text has been modified.
//   FALSE  text has not been modified.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETMODIFY, 0, 0);
//  
//  
//  AEM_SETMODIFY
//  _____________
//
//  Set the state of an edit control's modification flag.
//  
//  (BOOL)wParam == TRUE   text has been modified.
//                  FALSE  text has not been modified.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETMODIFY, FALSE, 0);
//  
//  
//  AEM_UNDOBUFFERSIZE
//  __________________
//
//  Get the number of bytes stored in the undo queue.
//
//  wParam == not used.
//  lParam == not used.
//
//  Return Value
//   Number of bytes.
//
//  Example:
//   SendMessage(hWndEdit, AEM_UNDOBUFFERSIZE, 0, 0);
//
//
//  AEM_EXGETSEL
//  ____________
//
//  Retrieve the current selection information of an edit control. Simple form of AEM_GETSEL.
//
//  (AECHARINDEX *)wParam == selection start index. Can be NULL.
//  (AECHARINDEX *)lParam == selection end index. Can be NULL.
//
//  Return Value
//   TRUE   selection is not empty.
//   FALSE  selection is empty.
//
//  Example:
//   AECHARRANGE aecr;
//
//   SendMessage(hWndEdit, AEM_EXGETSEL, (WPARAM)&aecr.ciMin, (LPARAM)&aecr.ciMax);
//
//
//  AEM_EXSETSEL
//  ____________
//
//  Set the current selection of an edit control. Simple form of AEM_SETSEL.
//
//  (AECHARINDEX *)wParam == selection start index.
//  (AECHARINDEX *)lParam == selection end index.
//
//  Return Value
//   zero
//
//  Example:
//   AECHARRANGE aecr;
//   BOOL bCaretAtEnd=TRUE;
//
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&aecr.ciMin);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&aecr.ciMax);
//
//   if (bCaretAtEnd)
//     SendMessage(hWndEdit, AEM_EXSETSEL, (WPARAM)&aecr.ciMin, (LPARAM)&aecr.ciMax);
//   else
//     SendMessage(hWndEdit, AEM_EXSETSEL, (WPARAM)&aecr.ciMax, (LPARAM)&aecr.ciMin);
//
//
//  AEM_GETSEL
//  __________
//
//  Retrieve the current selection information of an edit control.
//
//  (AECHARINDEX *)wParam == caret index, NULL if not needed.
//  (AESELECTION *)lParam == pointer to a AESELECTION structure, NULL if not needed.
//
//  Return Value
//   TRUE   selection is not empty.
//   FALSE  selection is empty.
//  
//  Example:
//   AESELECTION aes;
//   AECHARINDEX ciCaret;
//  
//   SendMessage(hWndEdit, AEM_GETSEL, (WPARAM)&ciCaret, (LPARAM)&aes);
//  
//  
//  AEM_SETSEL
//  __________
//  
//  Set the current selection of an edit control.
//  
//  (AECHARINDEX *)wParam == caret index, can be NULL.
//  (AESELECTION *)lParam == pointer to a AESELECTION structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AESELECTION aes;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&aes.crSel.ciMin);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&aes.crSel.ciMax);
//   aes.dwFlags=0;
//   SendMessage(hWndEdit, AEM_SETSEL, (WPARAM)&aes.crSel.ciMax, (LPARAM)&aes);
//  
//  
//  AEM_GETCOLUMNSEL
//  ________________
//  
//  Retrieve the column mode of the current selection.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   selection is in column mode.
//   FALSE  selection is in non-column mode.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETCOLUMNSEL, 0, 0);
//  
//  
//  AEM_UPDATESEL
//  _____________
//
//  Update current selection.
//  
//  (DWORD)wParam == see AESELT_* defines.
//  lParam        == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_UPDATESEL, AESELT_LOCKSCROLL, 0);
//  
//  
//  AEM_GETLINENUMBER
//  ________________
//  
//  Retrieve the specified line number.
//
//  (int)wParam == see AEGL_* defines.
//  lParam == not used.
//  
//  Return Value
//   Zero based line number.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETLINENUMBER, AEGL_LINECOUNT, 0);
//  
//  
//  AEM_GETINDEX
//  ____________
//  
//  Retrieve the specified character index.
//  
//  (int)wParam           == see AEGI_* defines.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   Zero if failed, non-zero if success.
//  
//  Example:
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&ciChar);
//
//  
//  AEM_GETLINEINDEX
//  ________________
//  
//  Retrieve the first character index in the specified line.
//  
//  (int)wParam           == zero based line number.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_GETLINEINDEX, 10, (LPARAM)&ciChar);
//  
//  
//  AEM_INDEXUPDATE
//  _______________
//  
//  Update lpLine member of the AECHARINDEX structure, to avoid dangling of a pointer after text change.
//  
//  wParam                == not used.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   TRUE   success.
//   FALSE  failed.
//  
//  Example:
//   AESELECTION aes;
//  
//   SendMessage(hWndEdit, AEM_GETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"123");
//   SendMessage(hWndEdit, AEM_INDEXUPDATE, 0, (LPARAM)&aes.crSel.ciMin);
//   SendMessage(hWndEdit, AEM_INDEXUPDATE, 0, (LPARAM)&aes.crSel.ciMax);
//  
//  
//  AEM_INDEXCOMPARE
//  ________________
//
//  Compare two character indexes.
//  
//  (AECHARINDEX *)wParam == first character index.
//  (AECHARINDEX *)lParam == second character index.
//  
//  Return Value
//   -1  first index is less than second index
//    0  first index is equal to second index
//    1  first index is greater than second index
//  
//  Example:
//   AESELECTION aes;
//  
//   SendMessage(hWndEdit, AEM_GETSEL, (WPARAM)NULL, (LPARAM)&aes);
//   SendMessage(hWndEdit, AEM_INDEXCOMPARE, (WPARAM)&aes.crSel.ciMin, (LPARAM)&aes.crSel.ciMax);
//  
//  For better performance instead of AEM_INDEXCOMPARE message add:
//   #define AEC_INDEXCOMPARE
//   #include "AkelEdit.h"
//  And use AEC_IndexCompare call:
//   AEC_IndexCompare(&aes.crSel.ciMin, &aes.crSel.ciMax);
//  
//  
//  AEM_INDEXSUBTRACT
//  _________________
//  
//  Retrieve how many characters between two character indexes.
//  
//  wParam                    == not used.
//  (AEINDEXSUBTRACT *)lParam == pointer to a AEINDEXSUBTRACT structure.
//  
//  Return Value
//   Number of characters.
//  
//  Example:
//   AEINDEXSUBTRACT is;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&is.ciChar1);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&is.ciChar2);
//   is.bColumnSel=FALSE;
//   is.nNewLine=AELB_ASIS;
//   SendMessage(hWnd, AEM_INDEXSUBTRACT, 0, (LPARAM)&is);
//
//  
//  AEM_INDEXOFFSET
//  _______________
//  
//  Retrieve the target character index at the specified offset from source character index.
//  
//  wParam                  == not used.
//  (AEINDEXOFFSET *)lParam == pointer to a AEINDEXOFFSET structure.
//  
//  Return Value
//   Processed number of characters.
//  
//  Example:
//   AEINDEXOFFSET io;
//   AECHARINDEX ciCharIn;
//   AECHARINDEX ciCharOut;
//  
//   //Get 10 character index of the edit control
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&ciCharIn);
//   io.ciCharIn=&ciCharIn;
//   io.ciCharOut=&ciCharOut;
//   io.nOffset=10;
//   io.nNewLine=AELB_R;
//   SendMessage(hWnd, AEM_INDEXOFFSET, 0, (LPARAM)&io);
//  
//  
//  AEM_INDEXTORICHOFFSET
//  _____________________
//  
//  Convert AkelEdit character index to RichEdit offset.
//  
//  wParam                == not used.
//  (AECHARINDEX *)lParam == AkelEdit character index.
//  
//  Return Value
//   RichEdit offset.
//  
//  Example:
//   AECHARRANGE aecr;
//   CHARRANGE recr;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTVISIBLELINE, (LPARAM)&aecr.ciMin);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTVISIBLELINE, (LPARAM)&aecr.ciMax);
//   recr.cpMin=SendMessage(hWndEdit, AEM_INDEXTORICHOFFSET, 0, (LPARAM)&aecr.ciMin);
//   recr.cpMax=SendMessage(hWndEdit, AEM_INDEXTORICHOFFSET, 0, (LPARAM)&aecr.ciMax);
//   SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&recr);
//  
//  
//  AEM_RICHOFFSETTOINDEX
//  _____________________
//  
//  Convert RichEdit offset to AkelEdit character index.
//  
//  (DWORD)wParam         == RichEdit offset.
//  (AECHARINDEX *)lParam == AkelEdit character index.
//  
//  Return Value
//   zero
//  
//  Example:
//   AECHARRANGE aecr;
//   CHARRANGE recr;
//  
//   SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&recr);
//   SendMessage(hWndEdit, AEM_RICHOFFSETTOINDEX, (WPARAM)recr.cpMin, (LPARAM)&aecr.ciMin);
//   SendMessage(hWndEdit, AEM_RICHOFFSETTOINDEX, (WPARAM)recr.cpMax, (LPARAM)&aecr.ciMax);
//  
//  
//  AEM_ADDPOINT
//  ____________
//  
//  Add character index to a points stack. Character index will be updated after every text change.
//  
//  wParam                == not used.
//  (AECHARINDEX *)lParam == AkelEdit character index.
//  
//  Return Value
//   Pointer to a AEPOINT structure.
//  
//  Example:
//   AEPOINT *lpPoint;
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTSELCHAR, (LPARAM)&ciChar);
//   lpPoint=(AEPOINT *)SendMessage(hWndEdit, AEM_ADDPOINT, 0, (LPARAM)&ciChar);
//   SendMessage(hWndEdit, EM_REPLACESEL, TRUE, (LPARAM)"123");
//   ciChar=lpPoint->ciPoint;  //Read new position
//   SendMessage(hWndEdit, AEM_DELPOINT, (WPARAM)lpPoint, 0);
//  
//  
//  AEM_DELPOINT
//  ____________
//  
//  Delete character index from points stack.
//  
//  (AEPOINT *)wParam == pointer to a AEPOINT structure, returned by AEM_ADDPOINT.
//  lParam            == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   See AEM_ADDPOINT example.
//  
//  
//  AEM_GETINDEXCOLUMN
//  __________________
//  
//  Retrieve the character index column taking into account tab stop size.
//  
//  (DWORD)wParam         == low-order word:
//                            tab stop size in characters.
//                           high-order word:
//                            TRUE   scan all wrapped lines.
//                            FALSE  scan to first char in line.
//  (AECHARINDEX *)lParam == AkelEdit character index.
//  
//  Return Value
//   Character index column.
//  
//  Example:
//   AECHARINDEX ciCaret;
//   int nTabStop;
//  
//   nTabStop=SendMessage(hWndEdit, AEM_GETTABSTOP, 0, 0);
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_CARETCHAR, (LPARAM)&ciCaret);
//   SendMessage(hWndEdit, AEM_GETINDEXCOLUMN, MAKELONG(nTabStop, TRUE), (LPARAM)&ciCaret);
//  
//
//  AEM_GETWRAPLINE
//  _______________
//  
//  Convert unwrapped line number to wrapped line number.
//  
//  (int)wParam           == zero based unwrapped line.
//  (AECHARINDEX *)lParam == returned first character in wrapped line. Can be NULL.
//  
//  Return Value
//   Wrapped line.
//  
//  Example:
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_GETWRAPLINE, (WPARAM)10, (LPARAM)&ciChar);
//  
//  
//  AEM_GETUNWRAPLINE
//  _________________
//  
//  Convert wrapped line number to unwrapped line number.
//  
//  (int)wParam == zero based wrapped line.
//  lParam      == not used.
//  
//  Return Value
//   Unwrapped line.
//  
//  Example:
//   AECHARINDEX ciCaret;
//   int nUnwrappedLine;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_CARETCHAR, (LPARAM)&ciCaret);
//  
//   if (SendMessage(hWndEdit, AEM_GETWORDWRAP, 0, 0))
//     nUnwrappedLine=SendMessage(hWndEdit, AEM_GETUNWRAPLINE, (WPARAM)ciCaret.nLine, 0);
//   else
//     nUnwrappedLine=ciCaret.nLine;
//  
//  
//  AEM_CHARFROMPOS
//  _______________
//
//  Retrieve the closest wide character to a specified point in the client area of an edit control.
//  
//  (POINT *)wParam       == coordinates of a point in the control's client area.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   See AEPC_* defines.
//  
//  Example:
//   RECT rc;
//   AECHARINDEX ciFirstVisible;
//  
//   SendMessage(hWndEdit, AEM_GETRECT, 0, (LPARAM)&rc);
//   SendMessage(hWndEdit, AEM_CHARFROMPOS, (WPARAM)&rc.left, (LPARAM)&ciFirstVisible);
//  
//  
//  AEM_POSFROMCHAR
//  _______________
//  
//  Retrieve the client area coordinates of a specified character in an edit control.
//  
//  (POINT *)wParam       == coordinates of a point in the control's client area.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   See AEPC_* defines.
//  
//  Example:
//   POINT pt;
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTVISIBLELINE, (LPARAM)&ciChar);
//   SendMessage(hWndEdit, AEM_POSFROMCHAR, (WPARAM)&pt, (LPARAM)&ciChar);
//  
//  
//  AEM_GETRECT
//  ___________
//  
//  Retrieve the formatting rectangle of an edit control. The formatting 
//  rectangle is the limiting rectangle into which the control draws the text.
//
//  wParam         == not used.
//  (RECT *)lParam == pointer to a RECT structure that receives the formatting rectangle.
//
//  Return Value
//   zero
//  
//  Example:
//   RECT rc;
//  
//   SendMessage(hWndEdit, AEM_GETRECT, 0, (LPARAM)&rc);
//  
//  
//  AEM_SETRECT
//  ___________
//  
//  Set the formatting rectangle of an edit control. The formatting rectangle is the limiting rectangle into which the control draws the text.
//  
//  (BOOL)wParam   == TRUE   redraw edit window.
//                    FALSE  don't redraw edit window.
//  (RECT *)lParam == pointer to a RECT structure that specifies the new dimensions of the rectangle. If this parameter is NULL, the formatting rectangle is set to its default values.
//  
//  Return Value
//   zero
//  
//  Example:
//   RECT rc;
//  
//   rc.left=10;
//   rc.top=10;
//   rc.right=200;
//   rc.bottom=200;
//   SendMessage(hWndEdit, AEM_SETRECT, TRUE, (LPARAM)&rc);
//  
//  
//  AEM_GETSCROLLPOS
//  ________________
//  
//  Obtain the current and/or maximum scroll position of the edit control.
//  
//  (POINT *)wParam == pointer to a POINT structure that receives the maximum
//                     scroll position in the virtual text space of the document,
//                     expressed in pixels. Can be NULL.
//  (POINT *)lParam == pointer to a POINT structure that receives the upper-left
//                     corner position in the virtual text space of the document,
//                     expressed in pixels. Can be NULL.
//  
//  Return Value
//   zero
//  
//  Example:
//   POINT ptMax;
//   POINT ptPos;
//  
//   SendMessage(hWndEdit, AEM_GETSCROLLPOS, (WPARAM)&ptMax, (LPARAM)&ptPos);
//  
//  
//  AEM_SETSCROLLPOS
//  ________________
//  
//  Scroll an edit control to a particular point.
//  
//  wParam          == not used.
//  (POINT *)lParam == pointer to a POINT structure which specifies a point in the virtual text space of the document, expressed in pixels.
//  
//  Return Value
//   zero
//  
//  Example:
//   POINT pt;
//  
//   pt.x=20;
//   pt.y=10;
//   SendMessage(hWndEdit, AEM_SETSCROLLPOS, 0, (LPARAM)&pt);
//  
//  
//  AEM_SCROLL
//  __________
//  
//  Scroll the text horizontally or vertically in an edit control. This message is equivalent of WM_HSCROLL and WM_VSCROLL.
//  
//  ((DWORD)wParam == see AESB_* defines.
//  (int)lParam    == action that can be specified with AESB_HORZ:
//                  SB_LINELEFT  scrolls left by one character.
//                  SB_LINERIGHT scrolls right by one character.
//                  SB_PAGELEFT  scrolls left by the width of the window.
//                  SB_PAGERIGHT scrolls right by the width of the window.
//                  SB_LEFT      scrolls to the most left.
//                  SB_RIGHT     scrolls to the most right.
//                 action that can be specified with AESB_VERT:
//                  SB_LINEUP    scrolls one line up.
//                  SB_LINEDOWN  scrolls one line down.
//                  SB_PAGEUP    scrolls one page up.
//                  SB_PAGEDOWN  scrolls one page down.
//                  SB_TOP       scrolls to the most up.
//                  SB_BOTTOM    scrolls to the most down.
//  
//  Return Value
//   Pixels scrolled.
//
//  Example:
//   SendMessage(hWndEdit, AEM_SCROLL, AESB_VERT, SB_LINEDOWN);
//  
//  
//  AEM_LINESCROLL
//  ______________
//  
//  Scroll the text horizontally or vertically on the specified number of characters or lines.
//  
//  (DWORD)wParam == see AESB_* defines.
//  (int)lParam   == If AESB_HORZ specified, the number of characters to scroll horizontally.
//                   If AESB_VERT specified, the number of lines to scroll vertically.
//
//  Return Value
//   Pixels scrolled.
//
//  Example:
//   SendMessage(hWndEdit, AEM_LINESCROLL, AESB_VERT, -10);
//  
//  
//  AEM_SCROLLCARET
//  _______________
//  
//  Scroll the caret into view in an edit control.
//  
//  (DWORD)wParam == see AESC_* defines.
//  (DWORD)lParam == the low-order word contains the horizontal scroll unit,
//                   the high-order word contains the vertical scroll unit.
//  
//  Return Value
//   See AECSE_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SCROLLCARET, AESC_UNITCHARX|AESC_UNITCHARY, MAKELONG(1, 1));
//  
//  
//  AEM_SCROLLCARETTEST
//  ___________________
//  
//  Same as AEM_SCROLLCARET, but only test for scroll.
//  
//  (DWORD)wParam == see AESC_* defines.
//  (DWORD)lParam == the low-order word contains the horizontal scroll unit,
//                   the high-order word contains the vertical scroll unit.
//  
//  Return Value
//   See AECSE_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SCROLLCARETTEST, AESC_UNITCHARX|AESC_UNITCHARY, MAKELONG(1, 1));
//  
//  
//  AEM_LOCKSCROLL
//  ______________
//  
//  Lock scrolling of an edit control.
//  
//  (int)wParam  == SB_BOTH  lock horizontal and vertical scroll.
//                  SB_HORZ  lock horizontal scroll.
//                  SB_VERT  lock vertical scroll.
//  (BOOL)lParam == TRUE   lock scroll.
//                  FALSE  unlock scroll.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_LOCKSCROLL, SB_BOTH, TRUE);
//   SendMessage(hWndEdit, EM_SETSEL, (WPARAM)-1, (LPARAM)-1);
//   SendMessage(hWndEdit, AEM_LOCKSCROLL, SB_BOTH, FALSE);
//  
//  
//  AEM_GETERASERECT
//  ________________
//  
//  Retrieve the erasing rectangle of an edit control. Make sense in WM_ERASEBKGND respond.
//  
//  wParam         == not used.
//  (RECT *)lParam == pointer to a RECT structure that receives the erasing rectangle.
//  
//  Return Value
//   zero
//  
//  Example:
//   if (uMsg == WM_ERASEBKGND)
//   {
//     RECT rcErase;
//  
//     SendMessage(hWndEdit, AEM_GETERASERECT, 0, (LPARAM)&rcErase);
//     if (rcErase.left < 10)
//     {
//       //Don't erase left 10 pixels, to avoid flashing.
//       rcErase.left=10;
//       SendMessage(hWndEdit, AEM_SETERASERECT, 0, (LPARAM)&rcErase);
//     }
//   }
//  
//  AEM_SETERASERECT
//  ________________
//  
//  Set the erasing rectangle of an edit control. Make sense in WM_ERASEBKGND respond.
//  
//  wParam         == not used.
//  (RECT *)lParam == pointer to a RECT structure that specifies the new dimensions of the rectangle.
//  
//  Return Value
//   zero
//  
//  Example:
//   See AEM_GETERASERECT example.
//  
//  
//  AEM_GETCHARSIZE
//  _______________
//  
//  Retrieve current font character height and average width.
//  
//  (DWORD)wParam == see AECS_* defines.
//  lParam        == not used.
//  
//  Return Value
//   Integer that depend on AECS_* value.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETCHARSIZE, AECS_HEIGHT, 0);
//  
//  
//  AEM_GETSTRWIDTH
//  _______________
//  
//  Retrieve string width. Uses the currently selected font.
//  
//  (wchar_t *)wParam == unicode string.
//  (int)lParam       == string length.
//  
//  Return Value
//   String width.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETSTRWIDTH, (WPARAM)L"ABC", 3);
//  
//  
//  AEM_GETCARETPOS
//  _______________
//  
//  Obtain the current caret position.
//  
//  (POINT *)wParam == pointer to a POINT structure that receives the caret position in the client area coordinates, expressed in pixels. Can be NULL.
//  (POINT *)lParam == pointer to a POINT structure that receives the caret position in the virtual text space of the document, expressed in pixels. Can be NULL.
//  
//  Return Value
//   TRUE   caret is visible.
//   FALSE  caret isn't visible.
//  
//  Example:
//   POINT ptClient;
//   POINT ptGlobal;
//  
//   SendMessage(hWndEdit, AEM_GETCARETPOS, (LPARAM)&ptClient, (WPARAM)&ptGlobal);
//  
//  
//  AEM_GETCARETHORZINDENT
//  ______________________
//  
//  Retrieve caret horizontal indent. It's unchanged after VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT key pressed.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Caret horizontal indent in the virtual text space of the document.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETCARETHORZINDENT, 0, 0);
//  
//  
//  AEM_SETCARETHORZINDENT
//  ______________________
//  
//  Set caret horizontal indent. It's unchanged after VK_UP, VK_DOWN, VK_PRIOR, VK_NEXT key pressed.
//  
//  (DWORD)wParam == caret horizontal indent in the virtual text space of the document.
//  lParam        == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETCARETHORZINDENT, 10, 0);
//  
//  
//  AEM_CONVERTPOINT
//  ________________
//  
//  Convert position coordinates.
//  
//  (DWORD)wParam   == see AECPT_* defines.
//  (POINT *)lParam == pointer to a POINT structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   POINT pt;
//
//   pt.x=SendMessage(hWndEdit, AEM_GETCARETHORZINDENT, 0, 0);
//   pt.y=0;
//   SendMessage(hWndEdit, AEM_CONVERTPOINT, AECPT_GLOBALTOCLIENT, (LPARAM)&pt);
//  
//  
//  AEM_CONTROLCLASS
//  ________________
//  
//  Retrieve control class AkelEdit or RichEdit.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   See AECLASS_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_CONTROLCLASS, 0, 0);
//  
//  
//  AEM_CONTROLVERSION
//  __________________
//  
//  Retrieve control version.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Version number. Created as: MAKE_IDENTIFIER(dwMajor, dwMinor, dwRelease, dwBuild).
//  
//  Example:
//   DWORD dwVersion;
//   DWORD dwMajor;
//   DWORD dwMinor;
//   DWORD dwRelease;
//   DWORD dwBuild;
//  
//   dwVersion=SendMessage(hWndEdit, AEM_CONTROLVERSION, 0, 0);
//   dwMajor=LOBYTE(LOWORD(dwVersion));
//   dwMinor=HIBYTE(LOWORD(dwVersion));
//   dwRelease=LOBYTE(HIWORD(dwVersion));
//   dwBuild=HIBYTE(HIWORD(dwVersion));
//  
//  
//  AEM_GETEVENTMASK
//  ________________
//  
//  Retrieve the event mask for an edit control. The event mask specifies which notification messages the control sends to its parent window.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   See AENM_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETEVENTMASK, 0, 0);
//  
//  
//  AEM_SETEVENTMASK
//  ________________
//  
//  Set the event mask for an edit control. The event mask specifies which notification messages the control sends to its parent window.
//  
//  wParam        == not used.
//  (DWORD)lParam == see AENM_* defines.
//  
//  Return Value
//   Previous event mask.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETEVENTMASK, 0, AENM_SELCHANGE|AENM_TEXTCHANGE|AENM_MODIFY);
//  
//  
//  AEM_GETOPTIONS
//  ______________
//  
//  Retrieve edit control options.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Combination of the current option flag values. See AECO_* defines.
//
//  Example:
//   SendMessage(hWndEdit, AEM_GETOPTIONS, 0, 0);
//  
//  
//  AEM_SETOPTIONS
//  ______________
//  
//  Set the options for an edit control.
//  
//  (DWORD)wParam == see AECOOP_* defines.
//  (DWORD)lParam == see AECO_* defines.
//  
//  Return Value
//   Current option of edit control.
//  
//  Example 1:
//   SendMessage(hWndEdit, AEM_SETOPTIONS, AECOOP_OR, AECO_DISABLEDRAG|AECO_DISABLEDROP);
//  
//  Example 2:
//   if (bDisableNoScroll)
//   {
//     SendMessage(hWndEdit, AEM_SETOPTIONS, AECOOP_OR, AECO_DISABLENOSCROLL);
//     ShowScrollBar(hWndEdit, SB_BOTH, TRUE);
//     SetScrollRange(hWndEdit, SB_HORZ, 0, 100, TRUE);
//     SetScrollRange(hWndEdit, SB_VERT, 0, 100, TRUE);
//     SendMessage(hWndEdit, AEM_UPDATESCROLLBAR, SB_BOTH, 0);
//   }
//   else
//   {
//     SendMessage(hWndEdit, AEM_SETOPTIONS, AECOOP_XOR, AECO_DISABLENOSCROLL);
//     ShowScrollBar(hWndEdit, SB_BOTH, TRUE);
//     SendMessage(hWndEdit, AEM_UPDATESCROLLBAR, SB_BOTH, 0);
//   }
//  
//  
//  AEM_GETNEWLINE
//  ______________
//  
//  Retrieve the default new line options for an edit control.
//  
//  wParam == not used.
//  lParam == not used.
//
//  Return Value
//   The low-order word contains the default input new line.
//   The high-order word contains the default output new line.
//  
//  Remarks
//   Possible new lines: AELB_ASIS, AELB_R, AELB_N, AELB_RN, AELB_RRN.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETNEWLINE, 0, 0);
//  
//  
//  AEM_SETNEWLINE
//  ______________
//  
//  Set the default new line options for an edit control.
//  
//  (DWORD)wParam == see AENL_* defines.
//  (DWORD)lParam == the low-order word contains the default input new line. Valid if AENL_INPUT is specified.
//                   the high-order word contains the default output new line. Valid if AENL_OUTPUT is specified.
//  
//  Return Value
//   zero
//  
//  Remarks
//   Possible new lines: AELB_ASIS, AELB_R, AELB_N, AELB_RN, AELB_RRN.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETNEWLINE, AENL_INPUT|AENL_OUTPUT, MAKELONG(AELB_R, AELB_RN));
//  
//  
//  AEM_GETCOLORS
//  _____________
//  
//  Retrieve colors of the edit control.
//  
//  wParam             == not used.
//  (AECOLORS *)lParam == pointer to a AECOLORS structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AECOLORS aec;
//  
//   aec.dwFlags=AECLR_ALL;
//   SendMessage(hWndEdit, AEM_GETCOLORS, 0, (LPARAM)&aec);
//  
//  
//  AEM_SETCOLORS
//  _____________
//  
//  Set colors of the edit control.
//  
//  wParam             == not used.
//  (AECOLORS *)lParam == pointer to a AECOLORS structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   AECOLORS aec;
//  
//   aec.dwFlags=AECLR_BASICTEXT|AECLR_BASICBK;
//   aec.crBasicText=GetSysColor(COLOR_WINDOWTEXT);
//   aec.crBasicBk=GetSysColor(COLOR_WINDOW);
//   SendMessage(hWndEdit, AEM_SETCOLORS, 0, (LPARAM)&aec);
//  
//  
//  AEM_GETDETECTURL
//  ________________
//  
//  Retrieve whether the URL detection is turned on.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   URL detection is on.
//   FALSE  URL detection is off.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETDETECTURL, 0, 0);
//  
//  
//  AEM_SETDETECTURL
//  ________________
//  
//  Enables or disables detection and highligthing of URLs by an edit control.
//  
//  (BOOL)wParam == TRUE   enable URL detection.
//                  FALSE  disable URL detection.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETDETECTURL, TRUE, 0);
//  
//  
//  AEM_GETOVERTYPE
//  _______________
//  
//  Retrieve type mode.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   TRUE   control is in overtype mode.
//   FALSE  control is in insert mode.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETOVERTYPE, 0, 0);
//  
//  
//  AEM_SETOVERTYPE
//  _______________
//  
//  Set type mode.
//  
//  (BOOL)wParam == TRUE   sets overtype mode.
//                  FALSE  sets insert mode.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETOVERTYPE, TRUE, 0);
//  
//  
//  AEM_GETCARETWIDTH
//  _________________
//  
//  Retrieve caret width.
//  
//  wParam          == not used.
//  (POINT *)lParam == pointer to a POINT structure that receives the insert mode caret width in x member and overtype mode caret height in y member.
//  
//  Return Value
//   zero
//  
//  Example:
//   POINT pt;
//  
//   SendMessage(hWndEdit, AEM_GETCARETWIDTH, 0, (LPARAM)&pt);
//  
//  
//  AEM_SETCARETWIDTH
//  _________________
//  
//  Set caret width.
//  
//  wParam          == not used.
//  (POINT *)lParam == pointer to a POINT structure which specifies the insert mode caret width in x member and overtype mode caret height in y member.
//  
//  Return Value
//   zero
//  
//  Example:
//   POINT pt;
//  
//   pt.x=2;
//   pt.y=3;
//   SendMessage(hWndEdit, AEM_SETCARETWIDTH, 0, (LPARAM)&pt);
//  
//  
//  AEM_GETTABSTOP
//  ______________
//  
//  Retrieve tab stop size.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Tab stop size in characters.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETTABSTOP, 0, 0);
//  
//  
//  AEM_SETTABSTOP
//  ______________
//  
//  Set tab stop size.
//  
//  (int)wParam == new tab stop size in characters.
//  lParam      == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETTABSTOP, 4, 0);
//  
//  
//  AEM_GETWORDWRAP
//  _______________
//  
//  Retrieve word wrap mode.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   See AEWW_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETWORDWRAP, 0, 0);
//  
//  
//  AEM_SETWORDWRAP
//  ______________
//  
//  Set word wrap mode.
//  
//  (int)wParam == see AEWW_* defines.
//  lParam      == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETWORDWRAP, AEWW_WORD, 0);
//  
//  
//  AEM_GETWORDDELIMITERS
//  _____________________
//  
//  Retrieve word break delimiters.
//  
//  (int)wParam       == size of the buffer in TCHARs.
//  (wchar_t *)lParam == pointer to a buffer that receives delimiter characters.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128];
//  
//   SendMessage(hWndEdit, AEM_GETWORDDELIMITERS, 128, (LPARAM)wszDelimiters);
//  
//  
//  AEM_SETWORDDELIMITERS
//  _____________________
//  
//  Set word break delimiters.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == string that specifies delimiter characters. If NULL, then default delimiters will be used.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128]=L" \t\n[](){}<>";
//  
//   SendMessage(hWndEdit, AEM_SETWORDDELIMITERS, 0, (LPARAM)wszDelimiters);
//  
//  
//  AEM_GETWRAPDELIMITERS
//  _____________________
//  
//  Retrieve word wrapping delimiters.
//  
//  (int)wParam       == size of the buffer in TCHARs.
//  (wchar_t *)lParam == pointer to a buffer that receives delimiter characters.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128];
//  
//   SendMessage(hWndEdit, AEM_GETWRAPDELIMITERS, 128, (LPARAM)wszDelimiters);
//  
//  
//  AEM_SETWRAPDELIMITERS
//  _____________________
//  
//  Set delimiters for word wrapping.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == string that specifies delimiter characters. If NULL, then default delimiters will be used.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128]=L" \t\n[](){}<>";
//  
//   SendMessage(hWndEdit, AEM_SETWRAPDELIMITERS, 0, (LPARAM)wszDelimiters);
//  
//  
//  AEM_GETURLDELIMITERS
//  ____________________
//  
//  Retrieve URL delimiters.
//
//  (int)wParam       == size of the buffer in TCHARs.
//  (wchar_t *)lParam == pointer to a buffer that receives delimiter characters.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128];
//  
//   SendMessage(hWndEdit, AEM_GETURLDELIMITERS, 128, (LPARAM)wszDelimiters);
//  
//  
//  AEM_SETURLDELIMITERS
//  ____________________
//  
//  Set delimiters for URL detection.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == string that specifies delimiter characters. If NULL, then default delimiters will be used.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszDelimiters[128]=L" \t\n[](){}<>";
//  
//   SendMessage(hWndEdit, AEM_SETURLDELIMITERS, 0, (LPARAM)wszDelimiters);
//  
//  
//  AEM_GETURLPREFIXES
//  __________________
//  
//  Retrieve URL prefixes.
//  
//  (int)wParam       == size of the buffer in TCHARs.
//  (wchar_t *)lParam == pointer to a buffer that receives pairs of null-terminated prefixes strings. The last string terminated by two NULL characters.
//  
//  Return Value
//   zero
//  
//  Example:
//   wchar_t wszPrefixes[128];
//
//   SendMessage(hWndEdit, AEM_GETURLPREFIXES, 128, (LPARAM)wszPrefixes);
//  
//  
//  AEM_SETURLPREFIXES
//  __________________
//  
//  Set prefixes for URL detection.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == buffer containing pairs of null-terminated prefixes strings. The last string in the buffer must be terminated by two NULL characters. If NULL, then default prefixes will be used.
//  
//  Return Value
//   Number of prefixes strings.
//  
//  Example:
//   wchar_t wszPrefixes[128]=L"http:\0https:\0www.\0ftp:\0file:\0mailto:\0\0"
//  
//   SendMessage(hWndEdit, AEM_SETURLPREFIXES, 0, (LPARAM)wszPrefixes);
//  
//  
//  AEM_GETURLMAXLENGTH
//  ___________________
//  
//  Retrieve URL maximum length.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   URL maximum length.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETURLMAXLENGTH, 0, 0);
//  
//  
//  AEM_SETURLMAXLENGTH
//  ___________________
//  
//  Set URL maximum length.
//  
//  (DWORD)wParam == URL maximum length (default is 512).
//  lParam        == not used.
//
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETURLMAXLENGTH, 1024, 0);
//  
//  
//  AEM_GETWORDBREAK
//  ________________
//  
//  Retrieve word break movement.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   See AEWB_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETWORDBREAK, 0, 0);
//  
//  
//  AEM_SETWORDBREAK
//  ________________
//  
//  Set word break movement.
//  
//  (DWORD)wParam == see AEWB_* defines.
//  lParam        == not used.
//  
//  Return Value
//   Previous word break movement. See AEWB_* defines.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETWORDBREAK, AEWB_LEFTWORDSTART|AEWB_RIGHTWORDSTART, 0);
//  
//  
//  AEM_GETMARKER
//  _____________
//  
//  Retrieve marker column.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Column number, zero if no marker set.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETMARKER, 0, 0);
//  
//  
//  AEM_SETMARKER
//  _____________
//  
//  Set marker at specified column.
//  
//  (int)wParam == column number, zero to clear marker.
//  lParam      == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETMARKER, 80, 0);
//  
//  
//  AEM_GETLINEGAP
//  ______________
//  
//  Retrieve character external leading.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Line gap (external leading).
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETLINEGAP, 0, 0);
//  
//  
//  AEM_SETLINEGAP
//  ______________
//  
//  Set character external leading.
//  
//  (int)wParam == line gap (external leading), default is zero.
//  lParam      == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_SETLINEGAP, 3, 0);
//  
//  
//  AEM_ISDELIMITER
//  _______________
//  
//  Retrieve character index delimiter or not.
//  
//  (int)wParam           == see AEDLM_* defines.
//  (AECHARINDEX *)lParam == character index.
//  
//  Return Value
//   TRUE   character index is a delimiter.
//   FALSE  character index isn't a delimiter.
//  
//  Example:
//   AECHARINDEX ciChar;
//  
//   SendMessage(hWndEdit, AEM_ISDELIMITER, AEDLM_WORD, (LPARAM)&ciChar);
//  
//  
//  AEM_SHOWSCROLLBAR
//  _________________
//  
//  Show or hide scroll bars in the edit control.
//  
//  (int)wParam  == SB_BOTH  horizontal and vertical scroll bars.
//                  SB_HORZ  horizontal scroll bar.
//                  SB_VERT  vertical scroll bar.
//  (BOOL)lParam == TRUE   show.
//                  FALSE  hide.
//  
//  Return Value
//   zero
//
//  Example:
//   SendMessage(hWndEdit, AEM_SHOWSCROLLBAR, SB_BOTH, FALSE);
//  
//  
//  AEM_UPDATESCROLLBAR
//  ___________________
//  
//  Update scroll bars in the edit control.
//  
//  (int)wParam  == SB_BOTH  horizontal and vertical scroll bars.
//                  SB_HORZ  horizontal scroll bar.
//                  SB_VERT  vertical scroll bar.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_UPDATESCROLLBAR, SB_BOTH, 0);
//  
//  
//  AEM_HIDESELECTION
//  _________________
//  
//  Hides or shows the selection in an edit control.
//  
//  (BOOL)wParam == TRUE   hide selection.
//                  FALSE  show selection.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HIDESELECTION, TRUE, 0);
//  
//  
//  AEM_ADDCLONE
//  ____________
//  
//  Adds clone to the master window. Message sended to a master window which will be cloned.
//  
//  (HWND)wParam == edit control handle which become a clone. Text of the master and clone windows will be the same.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_ADDCLONE, (HWND)hWndEdit2, 0);
//  
//  
//  AEM_DELCLONE
//  ____________
//  
//  Removes clone from the master window. Message sended to a master window.
//  
//  (HWND)wParam == edit control handle that will lose clone status. Text of the clone window will be restored.
//  lParam       == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_DELCLONE, (HWND)hWndEdit2, 0);
//  
//  
//  AEM_GETMASTER
//  _____________
//  
//  Retrieve master window handle. Message sended to a master or slave window.
//  
//  wParam == not used.
//  lParam == not used.
//  
//  Return Value
//   Master window handle.
//  
//  Example:
//   HWND hWndMaster;
//  
//   if (hWndMaster=(HWND)SendMessage(hWndEdit, AEM_GETMASTER, 0, 0))
//   {
//     if (hWndMaster == hWndEdit)
//       MessageBox(NULL, "hWndEdit is master", NULL, 0);
//     else
//       MessageBox(NULL, "hWndEdit is slave", NULL, 0);
//   }
//   else MessageBox(NULL, "hWndEdit nor master, nor slave", NULL, 0);
//  
//  
//  AEM_GETCLONE
//  ____________
//  
//  Retrieve clone window handle. Message sended to a master window.
//  
//  (DWORD)wParam == zero based clone index.
//  lParam        == not used.
//  
//  Return Value
//   Clone window handle.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_GETCLONE, 2, 0);
//  
//  
//  AEM_STARTPRINTDOC
//  _________________
//  
//  Prepare document printing.
//  
//  wParam            == not used.
//  (AEPRINT *)lParam == pointer to a AEPRINT structure.
//  
//  Return Value
//   Document handle.
//  
//  Example:
//   PRINTDLGA pdlg={0};
//   DOCINFOA di={0};
//   AEPRINT prn;
//   HANDLE hPrintDoc;
//   BOOL bPrintStop=FALSE;
//  
//   //Choose printer
//   pdlg.lStructSize=sizeof(PRINTDLGA);
//   pdlg.hwndOwner=hWndEdit;
//   pdlg.Flags=PD_ALLPAGES|PD_NOPAGENUMS|PD_RETURNDC|PD_USEDEVMODECOPIESANDCOLLATE;
//   pdlg.nCopies=1;
//   if (!PrintDlgA(&pdlg)) return;
//  
//   //Set print settings
//   prn.dwFlags=AEPRN_INHUNDREDTHSOFMILLIMETERS|AEPRN_WRAPWORD;
//   prn.hPrinterDC=pdlg.hDC;
//   prn.hEditFont=(HFONT)SendMessage(hWndEdit, WM_GETFONT, 0, 0);
//   prn.rcMargins.left=1000;
//   prn.rcMargins.top=1000;
//   prn.rcMargins.right=1000;
//   prn.rcMargins.bottom=1000;
//   if (pdlg.Flags & PD_SELECTION)
//   {
//     SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTSELCHAR, (LPARAM)&prn.crText.ciMin);
//     SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTSELCHAR, (LPARAM)&prn.crText.ciMax);
//   }
//   else
//   {
//     SendMessage(hWndEdit, AEM_GETINDEX, AEGI_FIRSTCHAR, (LPARAM)&prn.crText.ciMin);
//     SendMessage(hWndEdit, AEM_GETINDEX, AEGI_LASTCHAR, (LPARAM)&prn.crText.ciMax);
//   }
//  
//   //Document properties
//   di.cbSize=sizeof(DOCINFOA);
//   di.lpszDocName="AkelEdit document";
//   if (pdlg.Flags & PD_PRINTTOFILE)
//     di.lpszOutput="FILE:";
//  
//   //Start document
//   if (StartDocA(pdlg.hDC, &di) > 0)
//   {
//     if (hPrintDoc=(HANDLE)SendMessage(hWndEdit, AEM_STARTPRINTDOC, 0, (LPARAM)&prn))
//     {
//       while (!bPrintStop)
//       {
//         if (StartPage(prn.hPrinterDC) > 0)
//         {
//           //Print page
//           if (!SendMessage(hWndEdit, AEM_PRINTPAGE, (WPARAM)hPrintDoc, (LPARAM)&prn))
//             bPrintStop=TRUE;
//  
//           if (EndPage(prn.hPrinterDC) <= 0)
//             bPrintStop=TRUE;
//         }
//         else bPrintStop=TRUE;
//       }
//       SendMessage(hWndEdit, AEM_ENDPRINTDOC, (WPARAM)hPrintDoc, (LPARAM)&prn);
//     }
//     EndDoc(pdlg.hDC);
//   }
//   DeleteDC(pdlg.hDC);
//   pdlg.hDC=NULL;
//  
//  
//  AEM_PRINTPAGE
//  _____________
//  
//  Print page.
//  
//  (HANDLE)wParam    == document handle returned by AEM_STARTPRINTDOC.
//  (AEPRINT *)lParam == pointer to a AEPRINT structure.
//  
//  Return Value
//   TRUE   page is printed and there is more text for printing.
//   FALSE  page is printed and there is no more text for printing.
//  
//  Example:
//   See AEM_STARTPRINTDOC example.
//  
//  
//  AEM_ENDPRINTDOC
//  _______________
//  
//  Close print document handle.
//  
//  (HANDLE)wParam    == document handle returned by AEM_STARTPRINTDOC.
//  (AEPRINT *)lParam == pointer to a AEPRINT structure.
//  
//  Return Value
//   zero
//  
//  Example:
//   See AEM_STARTPRINTDOC example.
//  
//  
//  AEM_HLCREATETHEMEA
//  __________________
//  
//  Create empty highlight theme.
//  
//  wParam         == not used.
//  (char *)lParam == ansi theme name.
//  
//  Return Value
//   Theme handle.
//  
//  Example:
//   HANDLE hTheme;
//   AEDELIMITEMA di;
//   AEWORDITEMA wi;
//   AEQUOTEITEMA qi;
//   AEMARKRANGEITEM mri;
//   AEMARKTEXTITEMA mti;
//  
//   if (hTheme=(HANDLE)SendMessage(hWndEdit, AEM_HLCREATETHEMEA, 0, (LPARAM)"MyTheme"))
//   {
//     di.pDelimiter=" ";
//     di.nDelimiterLen=lstrlenA(di.pDelimiter);
//     di.dwFlags=AEHLF_MATCHCASE;
//     di.crText=(DWORD)-1;
//     di.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDDELIMITERA, (WPARAM)hTheme, (LPARAM)&di);
//  
//     wi.pWord="for";
//     wi.nWordLen=lstrlenA(wi.pWord);
//     wi.dwFlags=AEHLF_MATCHCASE;
//     wi.crText=RGB(0x00, 0xFF, 0x00);
//     wi.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDWORDA, (WPARAM)hTheme, (LPARAM)&wi);
//  
//     qi.pQuoteStart="\"";
//     qi.nQuoteStartLen=lstrlenA(qi.pQuoteStart);
//     qi.pQuoteEnd="\"";
//     qi.nQuoteEndLen=lstrlenA(qi.pQuoteEnd);
//     qi.chEscape='\\';
//     qi.dwFlags=AEHLF_MATCHCASE;
//     qi.crText=RGB(0x00, 0x00, 0xFF);
//     qi.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDQUOTEA, (WPARAM)hTheme, (LPARAM)&qi);
//
//     mri.crMarkRange.cpMin=10;
//     mri.crMarkRange.cpMax=20;
//     mri.dwFlags=0;
//     mri.crText=RGB(0xFF, 0x00, 0x00);
//     mri.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDMARKRANGE, (WPARAM)hTheme, (LPARAM)&mri);
//  
//     mti.pMarkText="or";
//     mti.nMarkTextLen=lstrlenA(mti.pMarkText);
//     mti.dwFlags=AEHLF_MATCHCASE;
//     mti.crText=(DWORD)-1;
//     mti.crBk=RGB(0xFF, 0x00, 0x00);
//     SendMessage(hWndEdit, AEM_HLADDMARKTEXTA, (WPARAM)hTheme, (LPARAM)&mti);
//  
//     SendMessage(hWndEdit, AEM_HLSETTHEME, (WPARAM)hTheme, TRUE);
//   }
//  
//  
//  AEM_HLCREATETHEMEW
//  __________________
//  
//  Create empty highlight theme.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == unicode theme name.
//  
//  Return Value
//   Theme handle.
//  
//  Example:
//   HANDLE hTheme;
//   AEDELIMITEMW di;
//   AEWORDITEMW wi;
//   AEQUOTEITEMW qi;
//   AEMARKRANGEITEM mri;
//   AEMARKTEXTITEMW mti;
//  
//   if (hTheme=(HANDLE)SendMessage(hWndEdit, AEM_HLCREATETHEMEW, 0, (LPARAM)L"MyTheme"))
//   {
//     di.pDelimiter=L" ";
//     di.nDelimiterLen=lstrlenW(di.pDelimiter);
//     di.dwFlags=AEHLF_MATCHCASE;
//     di.crText=(DWORD)-1;
//     di.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDDELIMITERW, (WPARAM)hTheme, (LPARAM)&di);
//  
//     wi.pWord=L"for";
//     wi.nWordLen=lstrlenW(wi.pWord);
//     wi.dwFlags=AEHLF_MATCHCASE;
//     wi.crText=RGB(0x00, 0xFF, 0x00);
//     wi.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDWORDW, (WPARAM)hTheme, (LPARAM)&wi);
//  
//     qi.pQuoteStart=L"\"";
//     qi.nQuoteStartLen=lstrlenW(qi.pQuoteStart);
//     qi.pQuoteEnd=L"\"";
//     qi.nQuoteEndLen=lstrlenW(qi.pQuoteEnd);
//     qi.wchEscape=L'\\';
//     qi.dwFlags=AEHLF_MATCHCASE;
//     qi.crText=RGB(0x00, 0x00, 0xFF);
//     qi.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDQUOTEW, (WPARAM)hTheme, (LPARAM)&qi);
//  
//     mri.crMarkRange.cpMin=10;
//     mri.crMarkRange.cpMax=20;
//     mri.dwFlags=0;
//     mri.crText=RGB(0xFF, 0x00, 0x00);
//     mri.crBk=(DWORD)-1;
//     SendMessage(hWndEdit, AEM_HLADDMARKRANGE, (WPARAM)hTheme, (LPARAM)&mri);
//  
//     mti.pMarkText=L"or";
//     mti.nMarkTextLen=lstrlenW(mti.pMarkText);
//     mti.dwFlags=AEHLF_MATCHCASE;
//     mti.crText=(DWORD)-1;
//     mti.crBk=RGB(0xFF, 0x00, 0x00);
//     SendMessage(hWndEdit, AEM_HLADDMARKTEXTW, (WPARAM)hTheme, (LPARAM)&mti);
//  
//     SendMessage(hWndEdit, AEM_HLSETTHEME, (WPARAM)hTheme, TRUE);
//   }
//  
//  
//  AEM_HLGETTHEMEA
//  _______________
//  
//  Retrieve highlight theme handle.
//
//  wParam         == not used.
//  (char *)lParam == ansi theme name to retrieve. If NULL, active theme handle will be returned.
//  
//  Return Value
//   Theme handle.
//  
//  Example:
//   HANDLE hTheme=(HANDLE)SendMessage(hWndEdit, AEM_HLGETTHEMEA, 0, (LPARAM)"MyTheme");
//  
//  
//  AEM_HLGETTHEMEW
//  _______________
//  
//  Retrieve highlight theme handle.
//  
//  wParam            == not used.
//  (wchar_t *)lParam == unicode theme name to retrieve. If NULL, active theme handle will be returned.
//  
//  Return Value
//   Theme handle.
//  
//  Example:
//   HANDLE hTheme=(HANDLE)SendMessage(hWndEdit, AEM_HLGETTHEMEW, 0, (LPARAM)L"MyTheme");
//  
//  
//  AEM_HLGETTHEMENAMEA
//  ___________________
//  
//  Retrieve ansi highlight theme name.
//  
//  (HANDLE)wParam == theme handle.
//  (char *)lParam == pointer to a buffer that receives ansi highlight theme name. If NULL, return value is the required buffer size.
//  
//  Return Value
//   Length of the string copied to the buffer, in TCHARs, not including the terminating null character.
//  
//  Example:
//   char szThemeName[MAX_PATH];
//  
//   SendMessage(hWndEdit, AEM_HLGETTHEMENAMEA, (WPARAM)hTheme, (LPARAM)szThemeName);
//  
//  
//  AEM_HLGETTHEMENAMEW
//  ___________________
//  
//  Retrieve unicode highlight theme name.
//  
//  (HANDLE)wParam    == theme handle.
//  (wchar_t *)lParam == pointer to a buffer that receives unicode highlight theme name. If NULL, return value is the required buffer size.
//  
//  Return Value
//   Length of the string copied to the buffer, in TCHARs, not including the terminating null character.
//  
//  Example:
//   wchar_t wszThemeName[MAX_PATH];
//  
//   SendMessage(hWndEdit, AEM_HLGETTHEMENAMEW, (WPARAM)hTheme, (LPARAM)wszThemeName);
//  
//  
//  AEM_HLTHEMEEXISTS
//  _________________
//  
//  Retrieve highlight theme existence.
//  
//  (HANDLE)wParam == theme handle.
//  lParam         == not used.
//  
//  Return Value
//   TRUE   theme exists.
//   FALSE  theme doesn't exist.
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLTHEMEEXISTS, (WPARAM)hTheme, 0);
//  
//  
//  AEM_HLSETTHEME
//  ______________
//  
//  Activate highlight theme.
//  
//  (HANDLE)wParam == theme handle. If NULL, active theme will be deactivated.
//  (BOOL)lParam   == TRUE   redraw the edit window.
//                    FALSE  don't redraw the edit window.
//  
//  Return Value
//   zero
//  
//  Example:
//   See AEM_HLCREATETHEMEA or AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETETHEME
//  _________________
//  
//  Delete highlight theme.
//  
//  (HANDLE)wParam == theme handle. If NULL, delete all themes.
//  lParam         == not used.
//  
//  Return Value
//   zero
//  
//  Example:
//   HANDLE hTheme;
//  
//   hTheme=(HANDLE)SendMessage(hWndEdit, AEM_HLCREATETHEMEW, 0, (LPARAM)L"MyTheme");
//   SendMessage(hWndEdit, AEM_HLDELETETHEME, (WPARAM)hTheme, 0);
//  
//  
//  AEM_HLADDDELIMITERA
//  ___________________
//  
//  Add ansi delimiter to highlight theme.
//  
//  (HANDLE)wParam         == theme handle.
//  (AEDELIMITEMA *)lParam == pointer to a AEDELIMITEMA structure.
//  
//  Return Value
//   Delimiter handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEA example.
//  
//  
//  AEM_HLADDDELIMITERW
//  ___________________
//  
//  Add unicode delimiter to highlight theme.
//
//  (HANDLE)wParam         == theme handle.
//  (AEDELIMITEMW *)lParam == pointer to a AEDELIMITEMW structure.
//  
//  Return Value
//   Delimiter handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETEDELIMITER
//  _____________________
//  
//  Delete delimiter from highlight theme.
//  
//  (HANDLE)wParam == theme handle.
//  (HANDLE)lParam == delimiter handle. If NULL, delete all delimiters.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLDELETEDELIMITER, (WPARAM)hTheme, (LPARAM)hDelimiter);
//  
//  
//  AEM_HLADDWORDA
//  ______________
//  
//  Add ansi word to highlight theme.
//  
//  (HANDLE)wParam        == theme handle.
//  (AEWORDITEMA *)lParam == pointer to a AEWORDITEMA structure.
//  
//  Return Value
//   Word handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEA example.
//  
//  
//  AEM_HLADDWORDW
//  ______________
//
//  Add unicode word to highlight theme.
//  
//  (HANDLE)wParam        == theme handle.
//  (AEWORDITEMW *)lParam == pointer to a AEWORDITEMW structure.
//  
//  Return Value
//   Word handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETEWORD
//  ________________
//  
//  Delete word from highlight theme.
//  
//  (HANDLE)wParam == theme handle.
//  (HANDLE)lParam == word handle. If NULL, delete all words.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLDELETEWORD, (WPARAM)hTheme, (LPARAM)hWord);
//  
//  
//  AEM_HLADDQUOTEA
//  _______________
//  
//  Add ansi quote to highlight theme.
//  
//  (HANDLE)wParam         == theme handle.
//  (AEQUOTEITEMA *)lParam == pointer to a AEQUOTEITEMA structure.
//  
//  Return Value
//   Quote handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEA example.
//  
//  
//  AEM_HLADDQUOTEW
//  _______________
//  
//  Add unicode quote to highlight theme.
//  
//  (HANDLE)wParam         == theme handle.
//  (AEQUOTEITEMW *)lParam == pointer to a AEQUOTEITEMW structure.
//  
//  Return Value
//   Quote handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETEQUOTE
//  _________________
//  
//  Delete quote from highlight theme.
//  
//  (HANDLE)wParam == theme handle.
//  (HANDLE)lParam == quote handle. If NULL, delete all quotes.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLDELETEQUOTE, (WPARAM)hTheme, (LPARAM)hQuote);
//  
//  
//  AEM_HLADDMARKTEXTA
//  __________________
//  
//  Add ansi text mark to highlight theme.
//  
//  (HANDLE)wParam            == theme handle.
//  (AEMARKTEXTITEMA *)lParam == pointer to a AEMARKTEXTITEMA structure.
//  
//  Return Value
//   Text mark handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEA example.
//
//  
//  AEM_HLADDMARKTEXTW
//  __________________
//  
//  Add unicode text mark to highlight theme.
//  
//  (HANDLE)wParam            == theme handle.
//  (AEMARKTEXTITEMW *)lParam == pointer to a AEMARKTEXTITEMW structure.
//  
//  Return Value
//   Text mark handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETEMARKTEXT
//  ____________________
//  
//  Delete text mark from highlight theme.
//  
//  (HANDLE)wParam == theme handle.
//  (HANDLE)lParam == text mark handle. If NULL, delete all marks.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLDELETEMARKTEXT, (WPARAM)hTheme, (LPARAM)hMark);
//  
//  
//  AEM_HLADDMARKRANGE
//  __________________
//  
//  Add unicode range mark to highlight theme.
//  
//  (HANDLE)wParam            == theme handle.
//  (AEMARKRANGEITEM *)lParam == pointer to a AEMARKRANGEITEM structure.
//  
//  Return Value
//   Range mark handle.
//  
//  Example:
//   See AEM_HLCREATETHEMEW example.
//  
//  
//  AEM_HLDELETEMARKRANGE
//  _____________________
//  
//  Delete range mark from highlight theme.
//  
//  (HANDLE)wParam == theme handle.
//  (HANDLE)lParam == range mark handle. If NULL, delete all marks.
//  
//  Return Value
//   zero
//  
//  Example:
//   SendMessage(hWndEdit, AEM_HLDELETEMARKRANGE, (WPARAM)hTheme, (LPARAM)hMark);


//// UNICODE define

{$IFNDEF UNICODE}
const
  AES_AKELEDITCLASS = AES_AKELEDITCLASSA;
  {$EXTERNALSYM AES_AKELEDITCLASS}
  AES_RICHEDITCLASS = AES_RICHEDITCLASSA;
  {$EXTERNALSYM AES_RICHEDITCLASS}
type
  AEAPPENDTEXT = AEAPPENDTEXTA;
  {$EXTERNALSYM AEAPPENDTEXT}
  AEREPLACESEL = AEREPLACESELA;
  {$EXTERNALSYM AEREPLACESEL}
  AETEXTRANGE = AETEXTRANGEA;
  {$EXTERNALSYM AETEXTRANGE}
  AEFINDTEXT = AEFINDTEXTA;
  {$EXTERNALSYM AEFINDTEXT}
  AEDELIMITEM = AEDELIMITEMA;
  {$EXTERNALSYM AEDELIMITEM}
  AEWORDITEM = AEWORDITEMA;
  {$EXTERNALSYM AEWORDITEM}
  AEQUOTEITEM = AEQUOTEITEMA;
  {$EXTERNALSYM AEQUOTEITEM}
  AEMARKTEXTITEM = AEMARKTEXTITEMA;
  {$EXTERNALSYM AEMARKTEXTITEM}
const
  AEM_SETTEXT = AEM_SETTEXTA;
  {$EXTERNALSYM AEM_SETTEXT}
  AEM_APPENDTEXT = AEM_APPENDTEXTA;
  {$EXTERNALSYM AEM_APPENDTEXT}
  AEM_REPLACESEL = AEM_REPLACESELA;
  {$EXTERNALSYM AEM_REPLACESEL}
  AEM_GETTEXTRANGE = AEM_GETTEXTRANGEA;
  {$EXTERNALSYM AEM_GETTEXTRANGE}
  AEM_FINDTEXT = AEM_FINDTEXTA;
  {$EXTERNALSYM AEM_FINDTEXT}
  AEM_ISMATCH = AEM_ISMATCHA;
  {$EXTERNALSYM AEM_ISMATCH}
  AEM_HLCREATETHEME = AEM_HLCREATETHEMEA;
  {$EXTERNALSYM AEM_HLCREATETHEME}
  AEM_HLGETTHEME = AEM_HLGETTHEMEA;
  {$EXTERNALSYM AEM_HLGETTHEME}
  AEM_HLGETTHEMENAME = AEM_HLGETTHEMENAMEA;
  {$EXTERNALSYM AEM_HLGETTHEMENAME}
  AEM_HLADDDELIMITER = AEM_HLADDDELIMITERA;
  {$EXTERNALSYM AEM_HLADDDELIMITER}
  AEM_HLADDWORD = AEM_HLADDWORDA;
  {$EXTERNALSYM AEM_HLADDWORD}
  AEM_HLADDQUOTE = AEM_HLADDQUOTEA;
  {$EXTERNALSYM AEM_HLADDQUOTE}
  AEM_HLADDMARKTEXT = AEM_HLADDMARKTEXTA;
  {$EXTERNALSYM AEM_HLADDMARKTEXT}
{$ELSE}
const
  AES_AKELEDITCLASS = AES_AKELEDITCLASSW;
  {$EXTERNALSYM AES_AKELEDITCLASS}
  AES_RICHEDITCLASS = AES_RICHEDITCLASSW;
  {$EXTERNALSYM AES_RICHEDITCLASS}
type
  AEAPPENDTEXT = AEAPPENDTEXTW;
  {$EXTERNALSYM AEAPPENDTEXT}
  AEREPLACESEL = AEREPLACESELW;
  {$EXTERNALSYM AEREPLACESEL}
  AETEXTRANGE = AETEXTRANGEW;
  {$EXTERNALSYM AETEXTRANGE}
  AEFINDTEXT = AEFINDTEXTW;
  {$EXTERNALSYM AEFINDTEXT}
  AEDELIMITEM = AEDELIMITEMW;
  {$EXTERNALSYM AEDELIMITEM}
  AEWORDITEM = AEWORDITEMW;
  {$EXTERNALSYM AEWORDITEM}
  AEQUOTEITEM = AEQUOTEITEMW;
  {$EXTERNALSYM AEQUOTEITEM}
  AEMARKTEXTITEM = AEMARKTEXTITEMW;
  {$EXTERNALSYM AEMARKTEXTITEM}
const
  AEM_SETTEXT = AEM_SETTEXTW;
  {$EXTERNALSYM AEM_SETTEXT}
  AEM_APPENDTEXT = AEM_APPENDTEXTW;
  {$EXTERNALSYM AEM_APPENDTEXT}
  AEM_REPLACESEL = AEM_REPLACESELW;
  {$EXTERNALSYM AEM_REPLACESEL}
  AEM_GETTEXTRANGE = AEM_GETTEXTRANGEW;
  {$EXTERNALSYM AEM_GETTEXTRANGE}
  AEM_FINDTEXT = AEM_FINDTEXTW;
  {$EXTERNALSYM AEM_FINDTEXT}
  AEM_ISMATCH = AEM_ISMATCHW;
  {$EXTERNALSYM AEM_ISMATCH}
  AEM_HLCREATETHEME = AEM_HLCREATETHEMEW;
  {$EXTERNALSYM AEM_HLCREATETHEME}
  AEM_HLGETTHEME = AEM_HLGETTHEMEW;
  {$EXTERNALSYM AEM_HLGETTHEME}
  AEM_HLGETTHEMENAME = AEM_HLGETTHEMENAMEW;
  {$EXTERNALSYM AEM_HLGETTHEMENAME}
  AEM_HLADDDELIMITER = AEM_HLADDDELIMITERW;
  {$EXTERNALSYM AEM_HLADDDELIMITER}
  AEM_HLADDWORD = AEM_HLADDWORDW;
  {$EXTERNALSYM AEM_HLADDWORD}
  AEM_HLADDQUOTE = AEM_HLADDQUOTEW;
  {$EXTERNALSYM AEM_HLADDQUOTE}
  AEM_HLADDMARKTEXT = AEM_HLADDMARKTEXTW;
  {$EXTERNALSYM AEM_HLADDMARKTEXT}
{$ENDIF}

implementation

function AEC_IndexCompare(var ciChar1, ciChar2: TAECharIndex): integer;
begin
  if (ciChar1.nLine = ciChar2.nLine) and
     (ciChar1.nCharInLine = ciChar2.nCharInLine) then
    Result:= 0
  else
    if ((ciChar1.nLine < ciChar2.nLine) or
        ((ciChar1.nLine = ciChar2.nLine) and
         (ciChar1.nCharInLine < ciChar2.nCharInLine))) then
      Result:= -1
    else
      result:= 1;
end;

end.
